Attribute VB_Name = "Colors"
'    Copyright 2009, 2010 Makarov Andrey
'
'    This file is part of Audica - Open Simple Audio Player.
'
'    Audica is free software: you can redistribute it and/or modify
'    it under the terms of the GNU General Public License as published by
'    the Free Software Foundation, either version 3 of the License, or
'    (at your option) any later version.
'
'    Audica is distributed in the hope that it will be useful,
'    but WITHOUT ANY WARRANTY; without even the implied warranty of
'    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'    GNU General Public License for more details.
'
'    You should have received a copy of the GNU General Public License
'    along with Audica.  If not, see <http://www.gnu.org/licenses/>.

Option Explicit
Public C_Backcolor As Long ' 
Public C_Forecolor As Long
Public TitleColor As Long '  AUDICA
Public TitleShadow As Long '  AUDICA
Public SlidersFore As Long
Public C_PlaylistBack As Long
Public C_PlaylistBack2 As Long
Public C_PlaylistFore As Long
Public C_PlaylistGrid As Long
Public C_PlaylistSelectBack As Long
Public C_PlaylistPlayFore As Long
Public C_PlaylistPlayBack As Long
Public C_PlaylistNextFore As Long
Public C_TabsActiveLine As Long
Public C_TabsDragDropLine As Long
Public C_TabsBack As Long
Public C_TabsActiveFore As Long
Public C_TabsFore As Long
Private Const UCOLOR = 19
Private C() As String

Public Sub LoadColors(ByVal clr As String)
    C = Split(clr, ",")
    setColor(C_Backcolor, vbButtonFace) = 0
    setColor(TitleColor) = 1
    setColor(TitleShadow) = 2
    setColor(SlidersFore) = 3
    setColor(C_Forecolor, vbBlack) = 5
    setColor(C_PlaylistBack, vbWhite) = 7
    setColor(C_PlaylistBack2, &HFCFCFC) = 8
    setColor(C_PlaylistFore, 0) = 9
    setColor(C_PlaylistGrid, 1) = 10
    setColor(C_PlaylistSelectBack, &HF9E4E3) = 11
    setColor(C_PlaylistPlayFore, &H4080&) = 12
    setColor(C_PlaylistPlayBack, &H80C0FF) = 13
    setColor(C_PlaylistNextFore, &HC00000) = 14
'    setColor(C_TabsActiveLine, ) = 15
'    setColor(C_TabsDragDropLine, ) = 16
'    setColor(C_TabsBack, ) = 17
    setColor(C_TabsActiveFore, vbBlack) = 18
    setColor(C_TabsFore, &HC0C0C0) = 19
End Sub

Private Property Let setColor(ByRef Color As Long, Optional default As Long = -1, ByVal Index As Byte)
    If UUBound(C) < Index Then Color = default _
    Else If LenB(Trim$(C(Index))) <> 0 Then Color = cColor(val(C(Index))) Else Color = default
End Property

Public Sub ApplyColors()
    If UUBound(C) >= UCOLOR Then
        If LenB(Trim$(C(4))) <> 0 Then Form1.Progress.ColorSet(2) = cColor(val(C(4)))
        If LenB(Trim$(C(4))) <> 0 Then Form1.sld_vol.ColorSet(2) = cColor(val(C(4)))
        If LenB(Trim$(C(6))) <> 0 Then Form1.pic_song_inf.BackColor = cColor(val(C(6)))
    End If
End Sub
