VERSION 5.00
Begin VB.Form frmAddURL 
   AutoRedraw      =   -1  'True
   BorderStyle     =   0  'None
   Caption         =   "Form2"
   ClientHeight    =   420
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   6435
   BeginProperty Font 
      Name            =   "Verdana"
      Size            =   8.25
      Charset         =   204
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   LinkTopic       =   "Form2"
   ScaleHeight     =   28
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   429
   ShowInTaskbar   =   0   'False
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdAddUrl 
      Caption         =   "Add URL"
      Height          =   330
      Left            =   5040
      TabIndex        =   1
      Top             =   0
      Width           =   1395
   End
   Begin VB.ComboBox cmbUrl 
      Height          =   315
      Left            =   0
      TabIndex        =   0
      Text            =   "http://"
      Top             =   0
      Width           =   4815
   End
End
Attribute VB_Name = "frmAddURL"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'    Copyright 2010 Makarov Andrey
'
'    This file is part of Audica - Open Simple Audio Player.
'
'    Audica is free software: you can redistribute it and/or modify
'    it under the terms of the GNU General Public License as published by
'    the Free Software Foundation, either version 3 of the License, or
'    (at your option) any later version.
'
'    Audica is distributed in the hope that it will be useful,
'    but WITHOUT ANY WARRANTY; without even the implied warranty of
'    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'    GNU General Public License for more details.
'
'    You should have received a copy of the GNU General Public License
'    along with Audica.  If not, see <http://www.gnu.org/licenses/>.

Option Explicit
Private Declare Function DestroyWindow Lib "user32.dll" (ByVal hwnd As Long) As Long
Public DialogWnd As Long

Private Sub cmbUrl_GotFocus()
    cmbUrl.SelStart = 0
    cmbUrl.SelLength = Len(cmbUrl.Text)
End Sub

Private Sub cmdAddUrl_Click()
    If Form1.AddUrlToActivePlaylist(cmbUrl.Text) Then _
        SaveURLHistory cmbUrl.Text
    DestroyWindow DialogWnd
End Sub

Private Sub Form_Load()
    Dim i As Integer, ret As String
    For i = 0 To 9
        ret = IniStringPrivate("URLHistory", CStr(i), "<NOTHING>")
        If ret <> "<NOTHING>" Then
            cmbUrl.AddItem ret
        Else
            Exit Sub
        End If
    Next
End Sub

Private Sub SaveURLHistory(ByRef newItem As String)
    Dim i As Integer, written As Integer
    If LenB(newItem) Then
        Call IniDelAllKeyPrivate("URLHistory")
        Call IniWriteStrPrivate("URLHistory", "0", cmbUrl.Text)
        written = 1
        For i = 0 To cmbUrl.listCount
            If cmbUrl.List(i) <> newItem And written < 10 Then
                Call IniWriteStrPrivate("URLHistory", CStr(written), cmbUrl.List(i))
                inc written
            End If
        Next i
    End If
End Sub
