VERSION 5.00
Begin VB.Form frm_info 
   AutoRedraw      =   -1  'True
   BackColor       =   &H00FFC0C0&
   BorderStyle     =   0  'None
   Caption         =   "Form2"
   ClientHeight    =   495
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   6495
   BeginProperty Font 
      Name            =   "Verdana"
      Size            =   8.25
      Charset         =   204
      Weight          =   700
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   LinkTopic       =   "Form2"
   ScaleHeight     =   33
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   433
   ShowInTaskbar   =   0   'False
   StartUpPosition =   3  'Windows Default
   Begin VB.Timer Timer1 
      Left            =   120
      Top             =   0
   End
End
Attribute VB_Name = "frm_info"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'    Copyright 2009, 2010 Makarov Andrey
'
'    This file is part of Audica - Open Simple Audio Player.
'
'    Audica is free software: you can redistribute it and/or modify
'    it under the terms of the GNU General Public License as published by
'    the Free Software Foundation, either version 3 of the License, or
'    (at your option) any later version.
'
'    Audica is distributed in the hope that it will be useful,
'    but WITHOUT ANY WARRANTY; without even the implied warranty of
'    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'    GNU General Public License for more details.
'
'    You should have received a copy of the GNU General Public License
'    along with Audica.  If not, see <http://www.gnu.org/licenses/>.

Option Explicit
Private Declare Function GetWindowTextLength Lib "user32.dll" Alias "GetWindowTextLengthA" (ByVal hwnd As Long) As Long
Private Declare Function ShowWindow Lib "user32.dll" (ByVal hwnd As Long, ByVal nCmdShow As Long) As Long
Private Declare Function SetWindowPos Lib "user32" (ByVal hwnd As Long, ByVal hWndInsertAfter As Long, ByVal x As Long, ByVal y As Long, ByVal cx As Long, ByVal cy As Long, ByVal wFlags As Long) As Long
Private Const HWND_TOPMOST = -1
Private Const SWP_NOMOVE = &H2
Private Const SWP_NOSIZE = &H1
Private Const SW_SHOWNOACTIVATE As Long = 4
Private Const SW_RESTORE As Long = 9

Private Declare Function GetWindowLong Lib "user32" Alias "GetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long) As Long
Private Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long
Private Declare Function SetLayeredWindowAttributes Lib "user32" (ByVal hwnd As Long, ByVal crKey As Long, ByVal bAlpha As Byte, ByVal dwFlags As Long) As Long
Private Const LWA_ALPHA = &H2
Private Const LWA_COLORKEY As Long = &H1
Private Const GWL_EXSTYLE = (-20)
Private Const WS_EX_LAYERED = &H80000

Private Const DT_CENTER As Long = &H1

Public Sub showInfo(ByVal timing As Byte, ByRef info As String, Optional ByVal hdib As Long)
    Dim rc As RECT, hdibw As Long
    prtf frm_info.hdc, info, rc, , True
    frm_info.Cls
    SetRECT rc, hdibw, hdib
    prtf frm_info.hdc, info, rc, DT_CENTER
    If FreeImageAvailable Then
        If hdib Then _
            Call FreeImage_PaintDCEx(hdc, hdib, 0, 0, hdibw, ScaleHeight)
    End If
    Line (0, 0)-(ScaleWidth - 1, ScaleHeight - 1), &HFF8080, B
    frm_info.Refresh
    If timing Then
        ShowWindow hwnd, SW_SHOWNOACTIVATE
        '   ,     ()
        If Not ProcessOnTop Then _
            Call SetWindowPos(hwnd, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOMOVE Or SWP_NOSIZE)
        Timer1.Enabled = False
        Timer1.Interval = timing * 1000
        Timer1.Enabled = True
    End If
End Sub

Private Sub Form_Click()
    If Form1.WindowState = vbMinimized Then _
        ShowWindow Form1.hwnd, SW_RESTORE _
    Else Form1.show
End Sub

Private Sub Form_Load()
    Call SetWindowLong(hwnd, GWL_EXSTYLE, GetWindowLong(hwnd, GWL_EXSTYLE) Or WS_EX_LAYERED)
    Call SetLayeredWindowAttributes(hwnd, 16711935, 220, LWA_ALPHA Or LWA_COLORKEY)
End Sub

Private Sub Timer1_Timer()
    Call hide
    Timer1.Enabled = False
End Sub

Private Sub SetRECT(ByRef rc As RECT, ByRef hdibw As Long, ByVal hdib As Long)
    rc.Bottom = rc.Bottom + 16
    rc.Top = rc.Top + 8
    If FreeImageAvailable Then
        If hdib Then _
            hdibw = FreeImage_GetWidth(hdib) / (FreeImage_GetHeight(hdib) / rc.Bottom)
    End If
    rc.Left = hdibw
    rc.Right = rc.Right + 32 + hdibw
    If rc.Right < 433 Then rc.Right = 433
    Move (Screen.Width - rc.Right * Screen.TwipsPerPixelX) \ 2, 0, _
        rc.Right * Screen.TwipsPerPixelX, rc.Bottom * Screen.TwipsPerPixelY
End Sub
