VERSION 5.00
Begin VB.Form frm_prelisten 
   AutoRedraw      =   -1  'True
   BackColor       =   &H008080FF&
   BorderStyle     =   0  'None
   Caption         =   "Form2"
   ClientHeight    =   390
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   3885
   BeginProperty Font 
      Name            =   "Verdana"
      Size            =   8.25
      Charset         =   204
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   LinkTopic       =   "Form2"
   ScaleHeight     =   26
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   259
   ShowInTaskbar   =   0   'False
   StartUpPosition =   3  'Windows Default
   Begin VB.Timer Timer2 
      Interval        =   500
      Left            =   2640
      Top             =   0
   End
   Begin VB.Timer Timer1 
      Interval        =   50
      Left            =   3120
      Top             =   0
   End
   Begin Audica.ctl_progress pre_search 
      Height          =   375
      Left            =   15
      TabIndex        =   0
      Top             =   0
      Width           =   3855
      _ExtentX        =   6800
      _ExtentY        =   661
   End
   Begin VB.Shape shp0 
      BorderColor     =   &H00FF8080&
      Height          =   390
      Left            =   0
      Top             =   0
      Width           =   3885
   End
End
Attribute VB_Name = "frm_prelisten"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'    Copyright 2010 Makarov Andrey
'
'    This file is part of Audica - Open Simple Audio Player.
'
'    Audica is free software: you can redistribute it and/or modify
'    it under the terms of the GNU General Public License as published by
'    the Free Software Foundation, either version 3 of the License, or
'    (at your option) any later version.
'
'    Audica is distributed in the hope that it will be useful,
'    but WITHOUT ANY WARRANTY; without even the implied warranty of
'    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'    GNU General Public License for more details.
'
'    You should have received a copy of the GNU General Public License
'    along with Audica.  If not, see <http://www.gnu.org/licenses/>.

Option Explicit
Private Declare Function GetForegroundWindow Lib "user32.dll" () As Long
Private hprelisten As Long '  

Private Sub Form_Load()
    pre_search.ColorBk = &HFFC0C0
    pre_search.ColorSet(0) = &HFF8080
    pre_search.ColorSet(2) = &HFF8080
End Sub

Private Sub Form_Resize()
    pre_search.Width = ScaleWidth - 2
    shp0.Width = ScaleWidth
End Sub

Private Sub pre_search_PositionSetByMouse(ByRef pos As Double)
    BASS_ChannelSetPosition hprelisten, BASS_ChannelSeconds2Bytes(hprelisten, pre_search.position), BASS_POS_BYTE
End Sub

Private Sub Timer1_Timer()
    If GetForegroundWindow <> hwnd Then StopPrelistening
End Sub

Private Sub StopPrelistening()
    If hprelisten Then
        Call BASS_StreamFree(hprelisten)
        hprelisten = 0
        Form1.Mute False
    End If
    Unload Me
End Sub

Private Sub Timer2_Timer()
    pre_search.position = BASS_ChannelBytes2Seconds(hprelisten, BASS_ChannelGetPosition(hprelisten, BASS_POS_BYTE)) ' update position
    If BASS_ChannelIsActive(hprelisten) = BASS_ACTIVE_STOPPED Then StopPrelistening
End Sub

Public Function Prelisten(ByRef item As playItem) As Boolean
    If LenB(item.file) <> 0 And hprelisten = 0 Then
        If b(hprelisten, BASS_StreamCreateFile(BASSFALSE, StrPtr(item.file), item.Offset, item.Length, BASS_UNICODE)) Then
            Call BASS_ChannelPlay(hprelisten, BASSFALSE)
            Form1.Mute True
            pre_search.max = BASS_ChannelBytes2Seconds(hprelisten, BASS_ChannelGetLength(hprelisten, BASS_POS_BYTE))
            pre_search.position = 0
            Timer2.Enabled = True
            Call Timer2_Timer
            Prelisten = True
        End If
    Else
        qError "Prelisten: wrong parameters", LenB(item.file), hprelisten
    End If
End Function


