VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "io"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'    Copyright 2009, 2010 Makarov Andrey
'
'    This file is part of Audica - Open Simple Audio Player.
'
'    Audica is free software: you can redistribute it and/or modify
'    it under the terms of the GNU General Public License as published by
'    the Free Software Foundation, either version 3 of the License, or
'    (at your option) any later version.
'
'    Audica is distributed in the hope that it will be useful,
'    but WITHOUT ANY WARRANTY; without even the implied warranty of
'    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'    GNU General Public License for more details.
'
'    You should have received a copy of the GNU General Public License
'    along with Audica.  If not, see <http://www.gnu.org/licenses/>.

Option Explicit
'Clipboard---------------------------------------
Private Declare Function OpenClipboard Lib "user32" (ByVal hwnd As Long) As Long
Private Declare Function SetClipboardData Lib "user32" (ByVal Format As Long, ByVal hMem As Long) As Long
Private Declare Function CloseClipboard Lib "user32" () As Long
Private Declare Function EmptyClipboard Lib "user32" () As Long
Private Declare Function GlobalAlloc Lib "kernel32" (ByVal Flags As Long, ByVal ln As Long) As Long
Private Declare Function GlobalFree Lib "kernel32.dll" (ByVal hMem As Long) As Long
Private Declare Function GlobalLock Lib "kernel32" (ByVal hMem As Long) As Long
Private Declare Function GlobalUnlock Lib "kernel32" (ByVal hMem As Long) As Long
Private Declare Sub RtlMoveMemory Lib "kernel32" (ByVal pDest As Long, ByVal pSource As Long, ByVal ln As Long)
Private Const CF_UNICODETEXT = &HD&
Private Const GMEM_MOVEABLE = &O2&
Private Const GMEM_ZEROINIT = &O40&
'Clipboard---------------------------------------

Private Declare Function CloseHandle Lib "kernel32" (ByVal hObject As Long) As Long
Private Declare Function WriteFile Lib "kernel32" (ByVal hFile As Long, lpBuffer As Any, ByVal nNumberOfBytesToWrite As Long, lpNumberOfBytesWritten As Long, ByVal lpOverlapped As Long) As Long
Private Declare Function ReadFile Lib "kernel32" (ByVal hFile As Long, lpBuffer As Any, ByVal nNumberOfBytesToRead As Long, lpNumberOfBytesRead As Long, ByVal lpOverlapped As Long) As Long
Private Declare Function CreateFile Lib "kernel32" Alias "CreateFileW" (ByVal lpFileName As Long, ByVal dwDesiredAccess As Long, ByVal dwShareMode As Long, ByVal lpSecurityAttributes As Long, ByVal dwCreationDisposition As Long, ByVal dwFlagsAndAttributes As Long, ByVal hTemplateFile As Long) As Long
Private Declare Function GetFileSize Lib "kernel32.dll" (ByVal hFile As Long, ByRef lpFileSizeHigh As Long) As Long
Private Declare Function FlushFileBuffers Lib "kernel32" (ByVal hFile As Long) As Long
Private Declare Function SetFilePointer Lib "kernel32.dll" (ByVal hFile As Long, ByVal lDistanceToMove As Long, ByRef lpDistanceToMoveHigh As Long, ByVal dwMoveMethod As Long) As Long
Private Const FILE_ATTRIBUTE_NORMAL = &H80
'Private Const OPEN_ALWAYS = 4
'Private Const INVALID_HANDLE_VALUE = -1

Private Const GENERIC_WRITE = &H40000000
'Private Const GENERIC_READ = &H80000000

Private Declare Function GetOpenFileName Lib "comdlg32.dll" Alias "GetOpenFileNameW" (ByVal pOpenfilename As Long) As Long
Private Declare Function GetSaveFileName Lib "comdlg32.dll" Alias "GetSaveFileNameW" (ByVal pOpenfilename As Long) As Long
Private Const OFN_ALLOWMULTISELECT As Long = &H200  'Allow multi select (Open Dialog)
Private Const OFN_EXPLORER As Long = &H80000        'Set windows style explorer
Private Const OFN_FILEMUSTEXIST As Long = &H1000    'File must exist
Private Const OFN_HIDEREADONLY As Long = &H4        'Hide read-only check box (Open Dialog)
Private Const OFN_PATHMUSTEXIST As Long = &H800     'Path must exist
Private Const OFN_ENABLEHOOK As Long = &H20
Private Const OFN_ENABLESIZING As Long = &H800000
Private Const OFN_OVERWRITEPROMPT As Long = &H2
Private Const vbDoubleNull As String = vbNullChar & vbNullChar
Private Type OPENFILENAME
    lStructSize As Long
    hWndOwner As Long
    hInstance As Long
    lpstrFilter As String
    lpstrCustomFilter As String
    nMaxCustFilter As Long
    nFilterIndex As Long
    lpstrFile As String
    nMaxFile As Long
    lpstrFileTitle As String
    nMaxFileTitle As Long
    lpstrInitialDir As String
    lpstrTitle As String
    Flags As Long
    nFileOffset As Integer
    nFileExtension As Integer
    lpstrDefExt As String
    lCustData As Long
    lpfnHook As Long
    lpTemplateName As String
    
    pvReserved As Long
    dwReserved As Long
    FlagsEx As Long
End Type

Private Declare Function PathCombine_ Lib "shlwapi.dll" Alias "PathCombineW" (ByVal szDest As Long, ByVal lpszDir As Long, ByVal lpszFile As Long) As Long

Private Const MAX_PATH As Long = 4000 '32767 '260
Private Const MAX_PATH_B As Long = MAX_PATH * 2
Private Const MAX_ALTERNATE As Long = 14

Private Type FILETIME
    dwLowDateTime As Long
    dwHighDateTime As Long
End Type

Private Type WIN32_FIND_DATA
    dwFileAttributes As Long
    ftCreationTime As FILETIME
    ftLastAccessTime As FILETIME
    ftLastWriteTime As FILETIME
    nFileSizeHigh As Long
    nFileSizeLow As Long
    dwReserved0 As Long
    dwReserved1 As Long
'    cFileName As String * MAX_PATH
    cFileName(MAX_PATH_B) As Byte
    cAlternate As String * MAX_ALTERNATE
End Type

Private Declare Function FindFirstFile Lib "kernel32.dll" Alias "FindFirstFileW" (ByVal lpFileName As Long, ByRef lpFindFileData As WIN32_FIND_DATA) As Long
Private Declare Function FindNextFile Lib "kernel32.dll" Alias "FindNextFileW" (ByVal hFindFile As Long, ByRef lpFindFileData As WIN32_FIND_DATA) As Long
Private Declare Function FindClose Lib "kernel32.dll" (ByVal hFindFile As Long) As Long

Private Declare Function PathIsDirectory Lib "shlwapi.dll" Alias "PathIsDirectoryW" (ByVal pszPath As Long) As Long
Private Declare Function GetDriveType Lib "kernel32.dll" Alias "GetDriveTypeA" (ByVal nDrive As String) As Long
'Private Const DRIVE_UNKNOWN As Long = 0
'Private Const DRIVE_NO_ROOT_DIR As Long = 1
'Private Const DRIVE_REMOVABLE As Long = 2
Private Const DRIVE_FIXED As Long = 3
'Private Const DRIVE_REMOTE As Long = 4
'Private Const DRIVE_CDROM As Long = 5
'Private Const DRIVE_RAMDISK As Long = 6

Public Event DialogEvent(ByVal Evnt As Long, ByVal hDlg As Long)
Public Event InitDialog(ByVal hDlg As Long)
Public Event FileChange(ByVal hDlg As Long)
Public Event FolderChange(ByVal hDlg As Long)
Public Event DialogOK(ByRef bCancel As Boolean)
Public Event TypeChange(ByVal hDlg As Long)
Public Event DialogClose()

Public filesResult As Collection
Public foldersResult As Collection

Public Sub fflush()
    Set filesResult = New Collection
    Set foldersResult = New Collection
End Sub

Public Sub enumFiles(ByVal path As String, Optional ByVal fFilter As String = vbNullString)
    Call fflush
    Call searchFilesRecursive(path, fFilter)
End Sub

'Enum files in /path/ and it's subfolders
'CAUTION: Changes Form1.Caption to show progress
Public Sub enumFilesRecursive(ByRef path As String, Optional ByRef fFilter As String = vbNullString)
    Dim i As Integer, postfix As String, foldername As String
    foldername = PathFilename(path)
    If LenB(foldername) = 0 Then foldername = path
    postfix = " subfolder of """ & foldername & """"
    Call fflush
    Call searchFilesRecursive(path, fFilter)
    Do
        i = i + 1
        If i <= foldersResult.Count Then
            If i Mod 10 = 0 Then
                Form1.Caption = "Search in " & i & postfix
                DoPaintEvents
            End If
            Call searchFilesRecursive(foldersResult(i), fFilter)
        Else
            Exit Do
        End If
    Loop
End Sub

Private Sub searchFilesRecursive(ByRef directoryPath As String, ByRef fFilter As String)
    Dim locationName As String, l As Long
    Dim findData As WIN32_FIND_DATA
    Dim hFindFile As Long
    hFindFile = FindFirstFile(StrPtr("\\?\" & directoryPath & "\*"), findData)
    If (hFindFile <> INVALID_HANDLE_VALUE) Then
        Do
            l = InStr(1, findData.cFileName, vbNullChar)
            If l = 0 Then l = MAX_PATH + 1
            locationName = Left$(findData.cFileName, l - 1)
            If (locationName <> "." And locationName <> "..") Then
                If ((findData.dwFileAttributes And vbDirectory) <> 0) Then
                    Call foldersResult.Add(PathCombine(directoryPath, locationName))
                ElseIf fFilter = vbNullString Then
                    Call filesResult.Add(PathCombine(directoryPath, locationName))
                ElseIf checkRegExpMask(locationName, fFilter, vbTextCompare) Then
                    Call filesResult.Add(PathCombine(directoryPath, locationName))
                End If
            End If
        Loop While (FindNextFile(hFindFile, findData))
    End If
    Call FindClose(hFindFile)
End Sub

Private Function PathCombine(ByVal directoryPath As String, ByVal directoryName As String) As String
    Dim l As Long
    PathCombine = String$(MAX_PATH, vbNullChar)
    Call PathCombine_(StrPtr(PathCombine), StrPtr(directoryPath), StrPtr(directoryName))
    l = InStr(1, PathCombine, vbNullChar)
    If l = 0 Then l = MAX_PATH + 1
    PathCombine = Left$(PathCombine, l - 1)
End Function

Public Function addressIsFolder(ByVal sPath As String) As Boolean
   Dim result As Long
   result = PathIsDirectory(StrPtr(sPath))
   addressIsFolder = (result = vbDirectory) Or (result = 1)
End Function

Public Sub ShowOpen(ByVal hwnd As Long, ByVal Filter As String, ByVal title As String, Optional ByVal multi As Boolean = True, Optional ByVal Hook As Boolean = False)
    Set filesResult = New Collection
    Dim Of As OPENFILENAME
    Call fflush
    
    If multi Then 'If Multi Select then
        Of.Flags = OFN_ALLOWMULTISELECT Or OFN_EXPLORER Or OFN_PATHMUSTEXIST Or OFN_FILEMUSTEXIST Or OFN_HIDEREADONLY
        Of.lpstrFile = Space$(9999) & vbNullChar
        Of.lpstrFileTitle = Space$(9999) & vbNullChar
    Else
        Of.Flags = OFN_PATHMUSTEXIST Or OFN_FILEMUSTEXIST Or OFN_HIDEREADONLY
        Of.lpstrFile = String$(MAX_PATH, 0) & vbNullChar
        Of.lpstrFileTitle = String$(MAX_PATH, 0) & vbNullChar
    End If
    If Hook Then
        Of.Flags = Of.Flags Or OFN_ENABLEHOOK Or OFN_ENABLESIZING
        Of.lCustData = ObjPtr(Me)
        Of.lpfnHook = Address(AddressOf Comdlg32CallbackP)
    End If

    Of.hWndOwner = hwnd 'Handle to window
    If InStr(1, Filter, "|") Then _
        Of.lpstrFilter = Replace$(Filter, "|", vbNullChar) & vbDoubleNull 'File filter
    Of.lpstrTitle = title & vbNullChar 'Dialog title
    Of.lStructSize = Len(Of) 'Structure size in bytes
    Of.nFilterIndex = 1 'Filter index
    Of.nMaxFile = Len(Of.lpstrFile) 'Maximum file length
    Of.nMaxFileTitle = Len(Of.lpstrFileTitle) 'Maximum file title length
    
    If GetOpenFileName(VarPtr(Of)) <> 0 Then 'If there are no errors continue with opening file
        ParseFileName Of.lpstrFile
    End If
End Sub

Public Sub ShowSave(ByVal hwnd As Long, ByVal Filter As String, ByVal title As String, ByVal DefaultFilename As String, Optional ByVal Hook As Boolean = False)
    Set filesResult = New Collection
    Dim Of As OPENFILENAME
    Call fflush
    
    Of.Flags = OFN_PATHMUSTEXIST Or OFN_HIDEREADONLY Or OFN_OVERWRITEPROMPT
    Of.lpstrFile = DefaultFilename & String(MAX_PATH - Len(DefaultFilename), 0) & vbNullChar
    Of.lpstrFileTitle = String$(MAX_PATH, 0) & vbNullChar
    If Hook Then
        Of.Flags = Of.Flags Or OFN_ENABLEHOOK Or OFN_ENABLESIZING
        Of.lCustData = ObjPtr(Me)
        Of.lpfnHook = Address(AddressOf Comdlg32CallbackP)
    End If

    Of.hWndOwner = hwnd 'Handle to window
    If InStr(1, Filter, "|") Then _
        Of.lpstrFilter = Replace$(Filter, "|", vbNullChar) & vbDoubleNull 'File filter
    Of.lpstrTitle = title & vbNullChar 'Dialog title
    Of.lStructSize = Len(Of) 'Structure size in bytes
    Of.nFilterIndex = 1 'Filter index
    Of.nMaxFile = Len(Of.lpstrFile) 'Maximum file length
    Of.nMaxFileTitle = Len(Of.lpstrFileTitle) 'Maximum file title length
    
    If GetSaveFileName(VarPtr(Of)) <> 0 Then 'If there are no errors continue with opening file
        ParseFileName Of.lpstrFile
    End If
End Sub

Private Function Address(ByVal Of As Long) As Long
    Address = Of
End Function

Public Sub Callback_WM_DIALOG(ByVal Evnt As Long, ByVal hDlg As Long)
    RaiseEvent DialogEvent(Evnt, hDlg)
End Sub

'** Remove null chars from filename and parse multi filename
Private Sub ParseFileName(ByRef sFileName As String)
    Dim stripped As String, arr() As String, i As Integer
    stripped = Left$(sFileName, InStr(1, sFileName, vbDoubleNull) - 1)
    arr = Split(stripped, vbNullChar)
    If UBound(arr) = 0 Then
        filesResult.Add arr(0)
    Else
        If Right$(arr(0), 1) <> "\" Then arr(0) = arr(0) & "\"
        For i = 1 To UBound(arr)
            filesResult.Add arr(0) & arr(i)
        Next i
    End If
End Sub

Public Function IsDriveFixed(ByVal nDrive As String) As Boolean
    IsDriveFixed = (GetDriveType(nDrive) = DRIVE_FIXED)
End Function

Public Function openFile(ByVal file As String, ByVal creation As Long, Optional ByVal access As Long = GENERIC_WRITE Or GENERIC_READ, Optional ByVal share As Long = 0) As Long
    openFile = CreateFile(StrPtr(file), access, share, 0, creation, FILE_ATTRIBUTE_NORMAL, 0)
End Function

Public Function getItemFromArr(ByRef dat() As Byte, ByRef pos As Long, ByRef ub As Long, ByRef item As playItem) As Boolean
    Dim intg As Integer, bool() As Boolean
    Set item = New playItem
    With item
    
    If pos > ub Then Exit Function
    bool = byteToBits(dat, pos)
    .gotTags = bool(0)
    .invalid = bool(1)
    .remote = bool(2)
    
    If pos + 3 > ub Then Exit Function
    .timing = byteToLng(dat, pos)
    
    If pos + 3 > ub Then Exit Function
    .offset = byteToLng(dat, pos)
    
    If pos + 3 > ub Then Exit Function
    .length = byteToLng(dat, pos)
    
    If pos + 1 > ub Then Exit Function
    intg = byteToInt(dat, pos)
    
    If pos + intg - 1 > ub Or intg < 0 Then Exit Function
    .artist = midFromArr(dat, pos, intg)
    
    If pos + 1 > ub Then Exit Function
    intg = byteToInt(dat, pos)
    
    If pos + intg - 1 > ub Or intg < 0 Then Exit Function
    .song = midFromArr(dat, pos, intg)
    
    If pos + 1 > ub Then Exit Function
    intg = byteToInt(dat, pos)

    If pos + intg - 1 > ub Or intg < 0 Then Exit Function
    .year = midFromArr(dat, pos, intg)

    If pos + 1 > ub Then Exit Function
    intg = byteToInt(dat, pos)
    
    If pos + intg - 1 > ub Or intg < 0 Then Exit Function
    .album = midFromArr(dat, pos, intg)

    If pos + 1 > ub Then Exit Function
    intg = byteToInt(dat, pos)
    
    If pos + intg - 1 > ub Or intg < 0 Then Exit Function
    .track = midFromArr(dat, pos, intg)
    
    If pos + 1 > ub Then Exit Function
    intg = byteToInt(dat, pos)
    
    If pos + intg - 1 > ub Or intg < 0 Then Exit Function
    .file = midFromArr(dat, pos, intg)  '#file path
    
    If LenB(.file) = 0 Then
        .file = "BAD_ITEM"
        Exit Function
    End If
    
    End With
    getItemFromArr = True
End Function

Public Function putItemToFile(ByVal lHandle As Long, ByRef item As playItem) As Long
    Dim dat() As Byte, pos As Long, bit_v() As Byte, offs As Boolean
    With item
    ReDim dat(LenB(.artist) + LenB(.song) + LenB(.file) + LenB(.album) + LenB(.track) + LenB(.year) + 25 - 1)
    bit_v = bitsToByte(.remote, .invalid, .gotTags)
    copyToArr dat, bit_v, pos '1 byte
    lngToArr dat, .timing, pos '4 bytes
    lngToArr dat, .offset, pos '4 bytes
    lngToArr dat, .length, pos '4 bytes
    intToArr dat, LenB(.artist), pos '2 bytes
    strToArr dat, .artist, pos
    intToArr dat, LenB(.song), pos '2 bytes
    strToArr dat, .song, pos
    intToArr dat, LenB(.year), pos '2 bytes
    strToArr dat, .year, pos
    intToArr dat, LenB(.album), pos '2 bytes
    strToArr dat, .album, pos
    intToArr dat, LenB(.track), pos '2 bytes
    strToArr dat, .track, pos
    intToArr dat, LenB(.file), pos '2 bytes
    strToArr dat, .file, pos
    writeBytesToFile lHandle, dat
    End With
End Function

Public Sub writeStringToFile(ByVal lHandle As Long, ByRef str As String)
    ReDim bytes(2 + LenB(str) - 1) As Byte
    intToArr bytes, LenB(str), 0 '2 bytes
    strToArr bytes, str, 2 'LenB(str) bytes
    writeBytesToFile lHandle, bytes
End Sub

Public Sub writeBoolToFile(ByVal lHandle As Long, ByRef bool As Boolean)
    Dim dat(0) As Byte, written As Long
    dat(0) = -bool
    WriteFile lHandle, dat(0), 1, written, 0
End Sub

Public Sub writeLongToFile(ByVal lHandle As Long, ByRef lng As Long)
    Dim dat(3) As Byte, written As Long
    lngToArr dat, lng, 0
    WriteFile lHandle, dat(0), 4, written, 0
End Sub

Public Sub writeBytesToFile(ByVal lHandle As Long, ByRef bytes() As Byte)
    Dim written As Long
    WriteFile lHandle, bytes(0), UUBound(bytes) + 1, written, 0
End Sub

Public Sub closeFile(ByVal lHandle As Long)
    FlushFileBuffers lHandle
    CloseHandle lHandle
End Sub

Public Function readFiledata(ByVal lHandle As Long, ByVal pos As Long, ByVal ln As Long, ByRef dest() As Byte) As Long
On Error GoTo 1:
    Dim lSuccess As Long
    SetFilePointer lHandle, pos, 0, 0 'FILE_BEGIN = 0
    lSuccess = ReadFile(lHandle, dest(0), ln, readFiledata, 0)
Exit Function
1:  qError "File read error. Handle", lHandle
End Function

Public Function sizeOfFile(ByVal lHandle As Long) As Long
    sizeOfFile = GetFileSize(lHandle, 0&)
End Function

Public Function sizeOfFileByPath(ByRef path As String) As Long
    Dim lHandle As Long
    sizeOfFileByPath = -1
    lHandle = CreateFile(StrPtr(path), GENERIC_READ, 0, 0, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, 0)
    If lHandle <> INVALID_HANDLE_VALUE Then
        sizeOfFileByPath = GetFileSize(lHandle, 0&)
        CloseHandle lHandle
    End If
End Function

Public Function ReadBytesFromFile(ByRef Filename As String, Optional ByVal ln As Long) As Byte()
On Error GoTo ErrorHandler
    Dim lHandle As Long, lSuccess As Long, lBytesRead As Long, lBytesToRead As Long
    lHandle = CreateFile(StrPtr(Filename), GENERIC_READ, 0, 0, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, 0)
    If lHandle <> INVALID_HANDLE_VALUE Then
        If ln Then lBytesToRead = ln _
        Else lBytesToRead = GetFileSize(lHandle, 0&)
        ReDim bytArr(lBytesToRead - 1) As Byte
        lSuccess = ReadFile(lHandle, bytArr(0), lBytesToRead, lBytesRead, 0)
        If lBytesRead Then _
            ReadBytesFromFile = bytArr
        CloseHandle lHandle
    End If
ErrorHandler:
End Function

Public Sub writeMagicToFile(ByVal hndl As Long, ByVal magic As String)
    ReDim bytes(Len(magic) - 1) As Byte
    Dim i As Integer
    For i = 0 To Len(magic) - 1
        bytes(i) = Asc(Mid$(magic, i + 1, 1))
    Next i
    writeBytesToFile hndl, bytes
End Sub

Public Sub putToClipboard(ByRef what As String)
    Dim hMem As Long, pMem As Long, ln As Long
    ln = LenB(what)
    Call OpenClipboard(0)
    Call EmptyClipboard
    hMem = GlobalAlloc(GMEM_MOVEABLE Or GMEM_ZEROINIT, ln + 2)
    pMem = GlobalLock(hMem)
    Call RtlMoveMemory(pMem, StrPtr(what), ln)
'    Call ZeroMemory(pMem + ln, 1)
    Call SetClipboardData(CF_UNICODETEXT, hMem)
    Call CloseClipboard
    Call GlobalUnlock(pMem)
    Call GlobalFree(hMem)
End Sub
