VERSION 5.00
Begin VB.Form Form1 
   AutoRedraw      =   -1  'True
   BorderStyle     =   5  'Sizable ToolWindow
   Caption         =   " Audica Uploader"
   ClientHeight    =   1815
   ClientLeft      =   120
   ClientTop       =   390
   ClientWidth     =   5895
   BeginProperty Font 
      Name            =   "Verdana"
      Size            =   8.25
      Charset         =   204
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   Icon            =   "Form1.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   121
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   393
   ShowInTaskbar   =   0   'False
   StartUpPosition =   2  'CenterScreen
   Begin VB.TextBox Text2 
      BackColor       =   &H8000000F&
      BorderStyle     =   0  'None
      Height          =   1095
      Left            =   120
      Locked          =   -1  'True
      MultiLine       =   -1  'True
      TabIndex        =   1
      Text            =   "Form1.frx":000C
      Top             =   600
      Width           =   5655
   End
   Begin VB.TextBox Text1 
      Alignment       =   2  'Center
      BeginProperty Font 
         Name            =   "Verdana"
         Size            =   12
         Charset         =   204
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   390
      Left            =   120
      Locked          =   -1  'True
      ScrollBars      =   3  'Both
      TabIndex        =   0
      Text            =   "$URL"
      Top             =   120
      Width           =   5655
   End
   Begin VB.Menu mnu_up 
      Caption         =   "Upload to"
      Visible         =   0   'False
      Begin VB.Menu mnu_up_to 
         Caption         =   "(No scripts)"
         Index           =   0
      End
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'    Copyright 2010 Makarov Andrey
'
'    This file is part of Audica Upload Tool (Audica service program).
'
'    Audica is free software: you can redistribute it and/or modify
'    it under the terms of the GNU General Public License as published by
'    the Free Software Foundation, either version 3 of the License, or
'    (at your option) any later version.
'
'    Audica is distributed in the hope that it will be useful,
'    but WITHOUT ANY WARRANTY; without even the implied warranty of
'    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'    GNU General Public License for more details.
'
'    You should have received a copy of the GNU General Public License
'    along with Audica.  If not, see <http://www.gnu.org/licenses/>.

Option Explicit
Private Declare Function SetWindowPos Lib "user32" (ByVal hwnd As Long, ByVal hWndInsertAfter As Long, ByVal x As Long, ByVal y As Long, ByVal cx As Long, ByVal cy As Long, ByVal wFlags As Long) As Long
Private Const HWND_TOPMOST = -1
Private Const SWP_NOMOVE = &H2
Private Const SWP_NOSIZE = &H1
Private ChoosedScript As Integer

Private Sub Form_Load()
    Call SetWindowPos(hwnd, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOMOVE Or SWP_NOSIZE)
    Call loadUploadScripts
End Sub

Private Sub Form_Resize()
    If ScaleWidth > 16 Then
        Text1.Width = ScaleWidth - 16
        Text2.Width = ScaleWidth - Text2.Left - 8
    End If
    If ScaleHeight > Text2.Top + 8 Then
        Text2.Height = ScaleHeight - Text2.Top - 8
    End If
End Sub

Private Sub mnu_up_to_Click(Index As Integer)
    ChoosedScript = Index
End Sub

Private Sub Text1_GotFocus()
    Dim l As Long
    l = Len(Text1.Text)
    If l Then
        Text1.SelStart = 0
        Text1.SelLength = l
    End If
End Sub

Private Sub Text2_GotFocus()
    Dim l As Long
    l = Len(Text2.Text)
    If l Then
        Text2.SelStart = 0
        Text2.SelLength = l
    End If
End Sub

Private Sub loadUploadScripts()
    Dim i As Integer, tmp As String, file As String
    file = Dir$("upload_*.vbs")
    Do While Len(file)
        If i Then Load mnu_up_to(i)
        tmp = PathFilename(file, True)
        tmp = Right$(tmp, Len(tmp) - 7) '7 = Len("upload_")
        mnu_up_to(i).Caption = tmp
        file = Dir$
        i = i + 1
    Loop
    
    file = Dir$("upload_*.js")
    Do While Len(file)
        If i Then Load mnu_up_to(i)
        tmp = PathFilename(file, True)
        tmp = Right$(tmp, Len(tmp) - 7) '7 = Len("upload_")
        mnu_up_to(i).Caption = tmp
        file = Dir$
        i = i + 1
    Loop
End Sub

'  
Private Function PathFilename(ByRef pth As String, Optional withExt As Boolean) As String
    Dim p(0 To 1) As Integer
    p(0) = InStrRev(pth, "\") + 1
    If Not withExt Then p(1) = InStrRev(pth, ".")
    If p(1) Then
        If p(1) - p(0) > 0 Then PathFilename = Mid(pth, p(0), p(1) - p(0)) _
        Else PathFilename = "BAD_FILENAME"
    Else
        PathFilename = Mid(pth, p(0), 1000)
    End If
End Function

Public Function ChooseScriptFile() As String
    ChoosedScript = -1
    PopupMenu mnu_up
    If ChoosedScript >= 0 And ChoosedScript < mnu_up_to.Count Then _
        ChooseScriptFile = "upload_" & mnu_up_to(ChoosedScript).Caption
End Function
