VERSION 5.00
Begin VB.UserControl vbkFlat 
   AutoRedraw      =   -1  'True
   BackColor       =   &H00FFA7E9&
   ClientHeight    =   1035
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   4800
   BeginProperty Font 
      Name            =   "Verdana"
      Size            =   8.25
      Charset         =   204
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   MousePointer    =   99  'Custom
   ScaleHeight     =   1035
   ScaleWidth      =   4800
   Begin VB.Image imgIcon 
      Height          =   300
      Left            =   915
      Top             =   105
      Width           =   300
   End
End
Attribute VB_Name = "vbkFlat"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'    This file is part of Audica - Open Simple Audio Player.
'
'    Audica is free software: you can redistribute it and/or modify
'    it under the terms of the GNU General Public License as published by
'    the Free Software Foundation, either version 3 of the License, or
'    (at your option) any later version.
'
'    Audica is distributed in the hope that it will be useful,
'    but WITHOUT ANY WARRANTY; without even the implied warranty of
'    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'    GNU General Public License for more details.
'
'    You should have received a copy of the GNU General Public License
'    along with Audica.  If not, see <http://www.gnu.org/licenses/>.

Option Explicit
Private Declare Function SetCapture Lib "user32" (ByVal hwnd As Long) As Long
Private Declare Function GetCapture Lib "user32" () As Long
Private Declare Function ReleaseCapture Lib "user32" () As Long
Private Declare Function WindowFromPoint Lib "user32" (ByVal xPoint As Long, ByVal yPoint As Long) As Long
Private Declare Function GetCursorPos Lib "user32" (lpPoint As POINTAPI) As Long
Private Type POINTAPI
    X As Long
    Y As Long
End Type

Public Enum enmbtnType
    TextImage = 0
    ImageOnly = 1
    TextOnly = 2
End Enum
'Default Property Values:
Const m_def_showBorder = False
Const m_def_Caption = "FUUUCH!"
Const m_def_Value = 0
Const m_def_btnType = 0
Const m_def_Disabled = False
Const m_def_CaptionForeColor = &H773F19
Const m_def_BorderColor = &HA70A80
Const m_def_bgColor = &HFFA7E9
Const m_def_OverColor = &HF9E3F3
Const m_def_DownColor = &HBB499F
Const m_def_DownBorderColor = &HBB499F
'Property Variables:
Dim m_showBorder As Boolean
Dim m_Caption As String
Dim m_Value As Boolean
Dim m_btnType As enmbtnType
Dim m_Disabled As Boolean
Dim m_CaptionForeColor As OLE_COLOR
Dim m_BorderColor As OLE_COLOR
Dim m_bgColor As OLE_COLOR
Dim m_OverColor As OLE_COLOR
Dim m_DownColor As OLE_COLOR
Dim m_DownBorderColor As OLE_COLOR
'Dim m_Caption As String
'Event Declarations:
Event Click()
Event OnMouseEnter()
Event OnMouseLeave()
Event MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
Event OnMouseMove()
Event MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)

Const C_MOUSEOUT = 0
Const C_MOUSEIN = 1
Const C_MOUSEDOWN = 2

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=10,0,0,&H00FAE5D3&
Public Property Get bgColor() As OLE_COLOR
    bgColor = m_bgColor
End Property

Public Property Let bgColor(ByVal New_bgColor As OLE_COLOR)
    m_bgColor = New_bgColor
    PropertyChanged "bgColor"
    UserControl.BackColor = m_bgColor
    draw IIf(Not value, C_MOUSEOUT, C_MOUSEDOWN)
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=10,0,0,&H00FAE5D3&
Public Property Get OverColor() As OLE_COLOR
    OverColor = m_OverColor
End Property

Public Property Let OverColor(ByVal New_OverColor As OLE_COLOR)
    m_OverColor = New_OverColor
    PropertyChanged "OverColor"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=10,0,0,&H00FAE5D3&
Public Property Get DownColor() As OLE_COLOR
    DownColor = m_DownColor
End Property

Public Property Let DownColor(ByVal New_DownColor As OLE_COLOR)
    m_DownColor = New_DownColor
    PropertyChanged "DownColor"
End Property


Public Property Get DownBorderColor() As OLE_COLOR
    DownBorderColor = m_DownBorderColor
End Property

Public Property Let DownBorderColor(ByVal New_DownBorderColor As OLE_COLOR)
    m_DownBorderColor = New_DownBorderColor
    PropertyChanged "DownBorderColor"
End Property


Private Sub imgIcon_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
    UserControl_MouseMove Button, Shift, X, Y
End Sub

'Private Sub lbCaption_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
'    UserControl_MouseMove Button, Shift, X, Y
'End Sub

'Initialize Properties for User Control
Private Sub UserControl_InitProperties()
    m_bgColor = m_def_bgColor
    m_OverColor = m_def_OverColor
    m_DownColor = m_def_DownColor
    m_BorderColor = m_def_BorderColor
    m_CaptionForeColor = m_def_CaptionForeColor
    m_Disabled = m_def_Disabled
    UserControl.BackColor = m_bgColor
    DisableState
    m_btnType = m_def_btnType
    m_Value = m_def_Value
    Set UserControl.Font = Ambient.Font
    m_Caption = m_def_Caption
    m_showBorder = m_def_showBorder
End Sub

Private Sub UserControl_KeyDown(KeyCode As Integer, Shift As Integer)
    If KeyCode = 32 Then _
        draw C_MOUSEDOWN
End Sub

Private Sub UserControl_KeyUp(KeyCode As Integer, Shift As Integer)
    If m_Disabled Then Exit Sub
    Dim p As POINTAPI
    GetCursorPos p
    Dim ThisHwnd As Long
    ThisHwnd = WindowFromPoint(p.X, p.Y)
    
    If KeyCode = 32 Then
        If ThisHwnd = UserControl.hwnd Then
            draw C_MOUSEIN
        Else
            UserControl.BackColor = m_bgColor
'            lbCaption.ForeColor = m_CaptionForeColor
            renderText m_Caption, m_CaptionForeColor
        End If
    End If
End Sub

Private Sub UserControl_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
    Dim pt As POINTAPI
    draw C_MOUSEDOWN
    RaiseEvent MouseDown(Button, Shift, X, Y)
    GetCursorPos pt
    If WindowFromPoint(pt.X, pt.Y) <> hwnd Then DoMouseOut
End Sub

Private Sub UserControl_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
    draw IIf(Not value, C_MOUSEIN, C_MOUSEDOWN)
    RaiseEvent MouseUp(Button, Shift, X, Y)
    RaiseEvent Click
    Call SetCapture(UserControl.hwnd)
End Sub

'Load property values from storage
Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
    m_bgColor = PropBag.ReadProperty("bgColor", m_def_bgColor)
    m_OverColor = PropBag.ReadProperty("OverColor", m_def_OverColor)
    m_DownColor = PropBag.ReadProperty("DownColor", m_def_DownColor)
    m_DownBorderColor = PropBag.ReadProperty("DownBorderColor", m_def_DownBorderColor)
    m_BorderColor = PropBag.ReadProperty("BorderColor", m_def_BorderColor)
    m_CaptionForeColor = PropBag.ReadProperty("CaptionForeColor", m_def_CaptionForeColor)
'    lbCaption.Caption = PropBag.ReadProperty("Caption", "")
    m_Caption = PropBag.ReadProperty("Caption", m_def_Caption)
    m_Disabled = PropBag.ReadProperty("Disabled", m_def_Disabled)
    UserControl.BackColor = m_bgColor
    DisableState
    Set imgIcon.Picture = PropBag.ReadProperty("Icon", Nothing)
    m_btnType = PropBag.ReadProperty("btnType", m_def_btnType)
    setType
'    Set lbCaption.Font = PropBag.ReadProperty("Font", Ambient.Font)
    Set UserControl.Font = PropBag.ReadProperty("Font", Ambient.Font)
    m_Value = PropBag.ReadProperty("Value", m_def_Value)
    m_showBorder = PropBag.ReadProperty("showBorder", m_def_showBorder)
    
    draw C_MOUSEOUT
End Sub

Private Sub UserControl_Resize()
    If m_btnType = 0 Then
        imgIcon.Left = 45
    Else
        imgIcon.Left = (UserControl.Width - imgIcon.Width) \ 2
    End If
    
'    If m_btnType = 0 Then
'        lbCaption.Left = imgIcon.Width + imgIcon.Left + 45
'    Else
'        lbCaption.Left = (UserControl.Width - lbCaption.Width) \ 2
'    End If
    imgIcon.Top = (UserControl.Height - imgIcon.Height) \ 2
'    lbCaption.Top = (UserControl.Height - lbCaption.Height) \ 2
'    renderText m_Caption
    draw IIf(Not value, C_MOUSEOUT, C_MOUSEDOWN)
End Sub

'Write property values to storage
Private Sub UserControl_WriteProperties(PropBag As PropertyBag)

    Call PropBag.WriteProperty("bgColor", m_bgColor, m_def_bgColor)
    Call PropBag.WriteProperty("OverColor", m_OverColor, m_def_OverColor)
    Call PropBag.WriteProperty("DownColor", m_DownColor, m_def_DownColor)
    Call PropBag.WriteProperty("DownBorderColor", m_DownBorderColor, m_def_DownBorderColor)
    Call PropBag.WriteProperty("BorderColor", m_BorderColor, m_def_BorderColor)
    Call PropBag.WriteProperty("CaptionForeColor", m_CaptionForeColor, m_def_CaptionForeColor)
'    Call PropBag.WriteProperty("Caption", lbCaption.Caption, "")
    Call PropBag.WriteProperty("Caption", m_Caption, m_def_Caption)
    Call PropBag.WriteProperty("Disabled", m_Disabled, m_def_Disabled)
    Call PropBag.WriteProperty("Icon", imgIcon.Picture, Nothing)
    Call PropBag.WriteProperty("btnType", m_btnType, m_def_btnType)
'    Call PropBag.WriteProperty("Font", lbCaption.Font, Ambient.Font)
    Call PropBag.WriteProperty("Font", UserControl.Font, Ambient.Font)
    Call PropBag.WriteProperty("Value", m_Value, m_def_Value)
    Call PropBag.WriteProperty("showBorder", m_showBorder, m_def_showBorder)
End Sub

Private Sub UserControl_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
    If m_Disabled Then Exit Sub
    If ((X < 0) Or (X > UserControl.Width) Or (Y < 0) Or (Y > UserControl.Height)) Then 'MouseOut
         DoMouseOut
         Call ReleaseCapture
         'Mouse Out
     ElseIf GetCapture <> UserControl.hwnd Then 'MouseEnter
         DoMouseEnter
         Call SetCapture(UserControl.hwnd)
         'Mouse Enter
     Else
         'Mouse Move
         RaiseEvent OnMouseMove
    End If
End Sub

Private Sub DoMouseOut()
    draw IIf(Not value, C_MOUSEOUT, C_MOUSEDOWN)
    RaiseEvent OnMouseLeave
End Sub

Private Sub DoMouseEnter()
    draw IIf(Not value, C_MOUSEIN, C_MOUSEDOWN)
    RaiseEvent OnMouseEnter
End Sub
'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=10,0,0,&H00E79D4D
Public Property Get BorderColor() As OLE_COLOR
    BorderColor = m_BorderColor
End Property

Public Property Let BorderColor(ByVal New_BorderColor As OLE_COLOR)
    m_BorderColor = New_BorderColor
    PropertyChanged "BorderColor"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=10,0,0,&H00773F19&
Public Property Get CaptionForeColor() As OLE_COLOR
    CaptionForeColor = m_CaptionForeColor
End Property

Public Property Let CaptionForeColor(ByVal New_CaptionForeColor As OLE_COLOR)
    m_CaptionForeColor = New_CaptionForeColor
    PropertyChanged "CaptionForeColor"
End Property
'
''WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
''MappingInfo=lbCaption,lbCaption,-1,Caption
'Public Property Get Caption() As String
'    Caption = lbCaption.Caption
'End Property
'
'Public Property Let Caption(ByVal New_Caption As String)
'    lbCaption.Caption() = New_Caption
'    PropertyChanged "Caption"
'End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=0,0,0,False
Public Property Get disabled() As Boolean
    disabled = m_Disabled
End Property

Public Property Let disabled(ByVal New_Disabled As Boolean)
    m_Disabled = New_Disabled
    PropertyChanged "Disabled"
    Enabled = Not New_Disabled
    DisableState
End Property

Public Sub DisableState()
'    If m_Disabled Then
''        lbCaption.ForeColor = m_OverColor
'        renderText m_Caption, m_OverColor
'    Else
''        lbCaption.ForeColor = m_CaptionForeColor
'        renderText m_Caption, m_CaptionForeColor
'    End If
End Sub
'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=imgIcon,imgIcon,-1,Picture
Public Property Get Icon() As Picture
    Set Icon = imgIcon.Picture
End Property

Public Property Set Icon(ByVal New_Icon As Picture)
    Set imgIcon.Picture = New_Icon
    PropertyChanged "Icon"
    UserControl_Resize
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=1,0,0,0
Public Property Get btnType() As enmbtnType
    btnType = m_btnType
End Property

Public Property Let btnType(ByVal New_btnType As enmbtnType)
    m_btnType = New_btnType
    PropertyChanged "btnType"
    setType
End Property

Private Sub setType()
    Select Case m_btnType
        Case 0
            imgIcon.Visible = True
'            lbCaption.Visible = True
        Case 1
            imgIcon.Visible = True
'            lbCaption.Visible = False
        Case 2
            imgIcon.Visible = False
'            lbCaption.Visible = True
      End Select
      UserControl_Resize
End Sub

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=0,0,0,0
Public Property Get value() As Boolean
    value = m_Value
End Property

Public Property Let value(ByVal New_Value As Boolean)
    m_Value = New_Value
    PropertyChanged "Value"
    draw IIf(Not value, C_MOUSEOUT, C_MOUSEDOWN)
End Property

Private Sub renderText(ByVal str As String, Optional ByVal Color As Long = -1, Optional ByVal cx As Integer = -1)
    If Color <> -1 Then _
        ForeColor = Color
    If cx = -1 Then _
        cx = ScaleWidth \ 2 - TextWidth(str) \ 2
    CurrentY = ScaleHeight \ 2 - TextHeight(str) \ 2
    CurrentX = cx
    Print str
End Sub

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=UserControl,UserControl,-1,Font
Public Property Get Font() As Font
Attribute Font.VB_UserMemId = -512
    Set Font = UserControl.Font
End Property

Public Property Set Font(ByVal New_Font As Font)
    Set UserControl.Font = New_Font
    PropertyChanged "Font"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=13,0,0,
Public Property Get Caption() As String
    Caption = m_Caption
End Property

Public Property Let Caption(ByVal New_Caption As String)
    m_Caption = New_Caption
    renderText m_Caption
    PropertyChanged "Caption"
End Property

Private Sub draw(ByVal state As Integer)
Select Case state
Case C_MOUSEOUT:
    Cls
    UserControl.BackColor = m_bgColor
    If showBorder Then
        UserControl.Line (15, 0)-(UserControl.Width - 15, 0), m_BorderColor
        UserControl.Line (15, UserControl.Height - 15)-(UserControl.Width - 15, UserControl.Height - 15), m_BorderColor
        UserControl.Line (0, 15)-(0, UserControl.Height - 15), m_BorderColor
        UserControl.Line (UserControl.Width - 15, 15)-(UserControl.Width - 15, UserControl.Height - 15), m_BorderColor
    End If
'    lbCaption.ForeColor = m_CaptionForeColor
    If m_btnType = 2 Then _
        renderText m_Caption, m_CaptionForeColor
Case C_MOUSEIN:
    If m_Disabled Then Exit Sub
    Cls
    UserControl.BackColor = m_OverColor
    UserControl.Line (15, 0)-(UserControl.Width - 15, 0), m_BorderColor
    UserControl.Line (15, UserControl.Height - 15)-(UserControl.Width - 15, UserControl.Height - 15), m_BorderColor
    UserControl.Line (0, 15)-(0, UserControl.Height - 15), m_BorderColor
    UserControl.Line (UserControl.Width - 15, 15)-(UserControl.Width - 15, UserControl.Height - 15), m_BorderColor
    UserControl.ForeColor = m_bgColor
    UserControl.PSet (0, 0)
    UserControl.PSet (0, UserControl.Height - 15)
    UserControl.PSet (UserControl.Width - 15, 0)
    UserControl.PSet (UserControl.Width - 15, UserControl.Height - 15)
'    lbCaption.ForeColor = m_CaptionForeColor
    If m_btnType = 2 Then _
        renderText m_Caption, m_CaptionForeColor
Case C_MOUSEDOWN:
    If m_Disabled Then Exit Sub
    Cls
    UserControl.BackColor = m_DownColor
    UserControl.Line (15, 0)-(UserControl.Width - 15, 0), m_DownBorderColor
    UserControl.Line (15, UserControl.Height - 15)-(UserControl.Width - 15, UserControl.Height - 15), m_DownBorderColor
    UserControl.Line (0, 15)-(0, UserControl.Height - 15), m_DownBorderColor
    UserControl.Line (UserControl.Width - 15, 15)-(UserControl.Width - 15, UserControl.Height - 15), m_DownBorderColor
    UserControl.ForeColor = m_bgColor
    UserControl.PSet (0, 0)
    UserControl.PSet (0, UserControl.Height - 15)
    UserControl.PSet (UserControl.Width - 15, 0)
    UserControl.PSet (UserControl.Width - 15, UserControl.Height - 15)
'    lbCaption.ForeColor = vbWhite
    If m_btnType = 2 Then _
        renderText m_Caption, vbWhite
End Select
End Sub
'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=0,0,0,False
Public Property Get showBorder() As Boolean
Attribute showBorder.VB_Description = "Show border when cursor is out"
    showBorder = m_showBorder
End Property

Public Property Let showBorder(ByVal New_showBorder As Boolean)
    m_showBorder = New_showBorder
    PropertyChanged "showBorder"
End Property
