VERSION 5.00
Begin VB.Form frm_plst 
   AutoRedraw      =   -1  'True
   BackColor       =   &H80000005&
   Caption         =   "Form2"
   ClientHeight    =   3090
   ClientLeft      =   225
   ClientTop       =   555
   ClientWidth     =   4680
   ClipControls    =   0   'False
   KeyPreview      =   -1  'True
   LinkTopic       =   "Form2"
   ScaleHeight     =   206
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   312
   StartUpPosition =   3  'Windows Default
   Begin VB.PictureBox pnl_sort 
      AutoRedraw      =   -1  'True
      BorderStyle     =   0  'None
      ClipControls    =   0   'False
      BeginProperty Font 
         Name            =   "Arial"
         Size            =   8.25
         Charset         =   204
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   255
      Left            =   0
      ScaleHeight     =   17
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   145
      TabIndex        =   0
      TabStop         =   0   'False
      Top             =   0
      Width           =   2175
   End
   Begin VB.Timer tmr_explore 
      Enabled         =   0   'False
      Interval        =   1
      Left            =   3960
      Top             =   0
   End
   Begin VB.Menu popup0 
      Caption         =   "popup0"
      Visible         =   0   'False
      Begin VB.Menu mnu_openfld 
         Caption         =   "Open folder"
      End
      Begin VB.Menu mnu_setnxt 
         Caption         =   "Set next track"
      End
      Begin VB.Menu mnu_showtrack 
         Caption         =   "Show track"
         Begin VB.Menu mnu_curtrk 
            Caption         =   "Current track"
         End
         Begin VB.Menu mnu_nxttrk 
            Caption         =   "Next track"
         End
      End
      Begin VB.Menu mnu_line0 
         Caption         =   "-"
      End
      Begin VB.Menu mnu_search 
         Caption         =   "Search artist"
         Visible         =   0   'False
         Begin VB.Menu mnu_search_i 
            Caption         =   "<search engine>"
            Index           =   0
         End
      End
      Begin VB.Menu mnu_save_chainlink 
         Caption         =   "Save to file..."
      End
      Begin VB.Menu mnu_upload 
         Caption         =   "Upload to Internet"
      End
      Begin VB.Menu mnu_prelisten 
         Caption         =   "Prelisten"
      End
   End
End
Attribute VB_Name = "frm_plst"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'    Copyright 2009, 2010 Makarov Andrey
'
'    This file is part of Audica - Open Simple Audio Player.
'
'    Audica is free software: you can redistribute it and/or modify
'    it under the terms of the GNU General Public License as published by
'    the Free Software Foundation, either version 3 of the License, or
'    (at your option) any later version.
'
'    Audica is distributed in the hope that it will be useful,
'    but WITHOUT ANY WARRANTY; without even the implied warranty of
'    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'    GNU General Public License for more details.
'
'    You should have received a copy of the GNU General Public License
'    along with Audica.  If not, see <http://www.gnu.org/licenses/>.

Option Explicit
Public id As Integer 'ID     
Public title As String ' 
'------------------------------------------------------------
Private Type TYPE_TIMING
    files As Long
    length As Double
End Type
Private timing As TYPE_TIMING
Private Const CDIS_FOCUS As Long = &H10
Private Const CDIS_SELECTED As Long = &H1

Public WithEvents List As cListView
Attribute List.VB_VarHelpID = -1
Private randomQueue() As Long
Private chooseMethod_ As ENUM_choose
Private NotPlaying As Boolean '   ,    list.playing  
'Private ind_e As Long 'For backgrnd tag exploring
Const MAGIC_PL As String = "AU$" ' -
Private m_dragging As Boolean
Private Const vbDoubleNull As String = vbNullChar & vbNullChar

Private Declare Function ScreenToClient Lib "user32.dll" (ByVal hwnd As Long, ByRef lpPoint As POINTAPI) As Long
Private Declare Function ClientToScreen Lib "user32.dll" (ByVal hwnd As Long, ByRef lpPoint As POINTAPI) As Long
Private Declare Function GetClientRect Lib "user32.dll" (ByVal hwnd As Long, ByRef lpRect As RECT) As Long
Private Declare Function PtInRect Lib "user32.dll" (ByRef lpRect As RECT, ByVal x As Long, ByVal y As Long) As Long
Private sendToTab As Integer
Private origDummyScrlWdt As Long
Private dummyScrlWdt As Long

Private Declare Function DeactivateWindowTheme Lib "uxtheme.dll" Alias "SetWindowTheme" (ByVal hwnd As Long, Optional ByRef pszSubAppName As String = " ", Optional ByRef pszSubIdList As String = " ") As Long
Const WSB_PROP_CYVSCROLL = &H1
Const WSB_PROP_CXVSCROLL = &H8
Private Declare Function FlatSB_SetScrollProp Lib "comctl32" (ByVal hwnd As Long, ByVal Index As Long, ByVal NewValue As Long, ByVal fRedraw As Boolean) As Boolean
Private Declare Function FlatSB_GetScrollProp Lib "comctl32" (ByVal hwnd As Long, ByVal Index As Long, pValue As Long) As Boolean

Private Sub incrTiming(ByRef secs As Single)
    timing.length = timing.length + secs
End Sub

Private Sub decrTiming(ByRef secs As Single)
    timing.length = timing.length - secs
End Sub

Private Sub Form_Load()
    BackColor = C_Backcolor
    pnl_sort.BackColor = C_Backcolor
    pnl_sort.ForeColor = C_Forecolor
    Call InitListView1
End Sub

Private Sub InitListView1()
    Set List = New cListView
    Call List.Create(hwnd, LVS_REPORT + LVS_OWNERDATA + LVS_NOCOLUMNHEADER, 0, 0, ScaleWidth, ScaleHeight, , WS_EX_STATICEDGE) ' + LVS_NOCOLUMNHEADER
    Call List.SetStyleEx(LVS_EX_FULLROWSELECT + LVS_EX_LABELTIP + LVS_EX_FLATSB + IIf(C_PlaylistGrid, LVS_EX_GRIDLINES, 0)) 'LVS_EX_FLATSB +
    List.HeaderButtons = False
    List.AddColumn 0, "Song", 150
    List.AddColumn 1, "Artist", 100
    List.AddColumn 2, "Album", 100
    List.AddColumn 3, "By path", 45 'Track
    List.AddColumn 4, "", 40 'Timing
    List.BackColor = C_PlaylistBack
    List.ForeColor = C_PlaylistFore
    
    FlatSB_GetScrollProp List.hwnd, WSB_PROP_CXVSCROLL, dummyScrlWdt
    origDummyScrlWdt = dummyScrlWdt
    dummyScrlWdt = dummyScrlWdt + 5
    FlatSB_SetScrollProp List.hwnd, WSB_PROP_CYVSCROLL, 30, True
On Error GoTo 1:
    DeactivateWindowTheme List.hwnd
1:
End Sub

Public Property Let SetListScrollWidth(ByVal W As Integer)
    FlatSB_SetScrollProp List.hwnd, WSB_PROP_CXVSCROLL, W, True
    dummyScrlWdt = W + 5
End Property

Private Sub Form_Resize()
    Static oldWidth As Single
    Dim tmp As Single
    With List
    .block = True
    .Move 0, 0, ScaleWidth, ScaleHeight - IIf(MiniMode, 0, pnl_sort.Height)
    If oldWidth <> Width Then
        If Not MiniMode Then
            FlatSB_SetScrollProp List.hwnd, WSB_PROP_CYVSCROLL, 30, False
            SetListScrollWidth = origDummyScrlWdt
            tmp = ScaleWidth - 45 - 40 - dummyScrlWdt
            .ColumnWidth(0) = tmp / 7 * 3
            .ColumnWidth(1) = tmp / 7 * 2
            .ColumnWidth(2) = tmp / 7 * 2
            .ColumnWidth(3) = 44: .ColumnWidth(3) = 45  '1
            .ColumnWidth(4) = 39: .ColumnWidth(4) = 40  '2
        Else
            FlatSB_SetScrollProp List.hwnd, WSB_PROP_CYVSCROLL, 15, False
            SetListScrollWidth = 7
            tmp = ScaleWidth - dummyScrlWdt
            .ColumnWidth(0) = tmp / 5 * 3
            .ColumnWidth(1) = tmp / 5 * 2
            .ColumnWidth(2) = 0
            .ColumnWidth(3) = 0
            .ColumnWidth(4) = 0
        End If
        oldWidth = Width
    End If
    .block = False
    End With
    pnl_sort.Visible = Not MiniMode
    If Not MiniMode Then pnl_sort.Move 0, ScaleHeight - pnl_sort.Height, ScaleWidth
End Sub

' .
'  ,   
Public Sub resumePlaying()
    If List.Count > 0 And _
    Not List.playing = -1 Then
        Call prevTrack
    Else
        Call nextTrack
    End If
End Sub

Public Sub savePlaylist(ByVal path As String)
    Dim i As Integer, hndl As Long
    hndl = io.openFile(AppPath & path, CREATE_ALWAYS)
    If hndl <> INVALID_HANDLE_VALUE Then
        io.writeMagicToFile hndl, MAGIC_PL 'AU$
        io.writeStringToFile hndl, title
        io.writeBoolToFile hndl, chooseMethod = RANDOM
        io.writeLongToFile hndl, List.playing
        For i = 0 To List.Count - 1
            io.putItemToFile hndl, List.p_item(i)
        Next i
        io.closeFile hndl
    End If
End Sub

Public Sub loadPlaylist(ByVal path As String)
On Local Error GoTo 1:
    Dim dat() As Byte, pos As Long, ub As Long
    Dim item As playItem, scs As Boolean
    dat = io.ReadBytesFromFile(AppPath & path)
    ub = UUBound(dat)
    If (ub + 1) < Len(MAGIC_PL) + 2 + 1 + 4 Then Exit Sub 'Magic-Title-Random-Playing-...
    If Not checkMagicRecord(dat, MAGIC_PL, pos) Then
        con.WriteLine "Invalid playlist file.", d_ERROR
        Exit Sub
    End If
    title = readStrFromArr(dat, pos)
    chooseMethod = IIf(readBoolFromArr(dat, pos), RANDOM, LINEAR)

    NotPlaying = True
    List.playing = byteToLng(dat, pos)

    Call populationStart
    While io.getItemFromArr(dat, pos, ub, item)
        List.p_add item
        If item.gotTags Or item.remote Then
            incr timing.files
            incrTiming item.timing
        End If
    Wend
    Call populationFinish

    'Check if current track is outOfBounds
    If List.playing > List.Count - 1 Then _
        List.playing = -1
    List.EnsureVisible (List.playing)
Exit Sub
1:  qError "Error while parsing playlist. Last pos.", pos
    Call populationFinish
End Sub

Public Property Let ScrollTo(ByVal item As Long)
'    If item <= List.Count Then List.TopItem = item
End Property

Private Sub List_LostFocus()
    If dragging Then
        dragging = False
        Debug.Print "drag interrupted by LostFocus"
    End If
End Sub

'
Public Property Get dragging() As Boolean
    dragging = m_dragging
End Property

'
Public Property Let dragging(ByVal state As Boolean)
    If m_dragging And Not state Then Debug.Print "Stop dragging"
    m_dragging = state
    List.BlockKeyboard = state
    MousePointer = IIf(state, vbSizeAll, vbDefault)
End Property

Private Sub List_MouseMove(ByVal x As Long, ByVal y As Long, ByVal Shift As Integer)
    If dragging Then
        Dim pt As POINTAPI, Container As Object
        pt.x = x
        pt.y = y
        Set Container = Form1.tabs.Container
        If Client1PtInClient2Rect(List.hwnd, Container.hwnd, pt) Then
            sendToTab = pt.x \ (Container.Width / Form1.tabs.Count)
            Form1.tabs.draw sendToTab
            Exit Sub ' 
        ElseIf sendToTab <> -1 Then
            sendToTab = -1
            Form1.tabs.draw sendToTab
        End If
        
        '  -
        If y < 0 Then
            If List.TopItem > 0 Then _
                List.EnsureVisible (List.TopItem - 1)
        ElseIf y > List.Bottom Then
            If List.BottomItem < List.Count Then _
                List.EnsureVisible (List.BottomItem + 1)
        End If
    End If
End Sub

'  pt  wndFrom  wndTo
'RV: /true/ -  pt   wndTo
Private Function Client1PtInClient2Rect(ByVal wndFrom As Long, ByVal wndTo As Long, pt As POINTAPI) As Boolean
    Dim rc As RECT
    ClientToScreen wndFrom, pt
    ScreenToClient wndTo, pt
    GetClientRect wndTo, rc
    Client1PtInClient2Rect = PtInRect(rc, pt.x, pt.y)
End Function

Private Sub List_OnData(str As Long, ByVal Index As Long, ByVal SubItem As Long)
    'str = Index & " " & SubItem
    Dim item As playItem
    Set item = List.p_item(Index)
    ' - (_)-("")-("")-("")-("")
    ' - (URL)-("")
    With item
    Select Case SubItem
    Case 0:
        If LenB(.song) = 0 Then .song = IIf(Not .remote, PathFilename(.file), .file)
        str = .list_song
    Case 1:
        If .gotTags And Not .invalid Then _
            str = .list_artist
    Case 2:
        If .gotTags And Not .invalid Then _
            str = .list_album
    Case 3:
        If .gotTags And Not .invalid And Not .remote Then _
            str = .list_track
    Case 4:
        If (.gotTags And Not .invalid) Or .remote Then _
            str = .list_timing
    End Select
    If str = 0 Then str = StrPtr(vbDoubleNull)
    End With
End Sub

'  
Private Sub mnu_curtrk_Click()
    List.EnsureVisible List.playing
End Sub

'  
Private Sub mnu_nxttrk_Click()
    List.EnsureVisible List.following
End Sub

Private Sub mnu_openfld_Click()
    If Not List.p_item(List.ListIndex).remote Then _
        Shell "explorer /select, """ & List.p_item(List.ListIndex).file & """", vbNormalFocus _
    Else MsgBox "This is a remote source"
End Sub

Private Sub List_Click(ByVal iitem As Long, ByVal Button As MouseButtonConstants)
    If Button = vbRightButton Then
        If iitem = 65535 Then
            mnu_openfld.Visible = False
            mnu_setnxt.Visible = False
            mnu_line0.Visible = False
'            mnu_search.Visible = False
            mnu_save_chainlink.Visible = False
            mnu_upload.Visible = False
            mnu_prelisten.Visible = False
        Else
            Dim localt As Boolean
            localt = Not List.p_item(iitem).remote
            mnu_openfld.Visible = localt
            mnu_setnxt.Visible = True
            mnu_line0.Visible = localt
'            mnu_search.Visible = localt
            mnu_save_chainlink.Visible = List.p_item(iitem).isChainLink
            mnu_upload.Visible = localt And UploadToolAvailable
            mnu_prelisten.Visible = localt
        End If
        PopupMenu popup0
    End If
End Sub

Private Sub List_CustomDraw(ByVal lParam As Long, ret_val As Long)
    Call CopyMemory(udtNMLVCUSTOMDRAW, ByVal lParam, Len(udtNMLVCUSTOMDRAW))
    With udtNMLVCUSTOMDRAW.nmcd
    If .dwDrawStage = CDDS_PREPAINT Then
        ret_val = CDRF_NOTIFYITEMDRAW
'    ElseIf .dwDrawStage = CDDS_ITEMPOSTPAINT Then
'        Debug.Print "CDDS_ITEMPOSTPAINT"
'        ret_val = CDRF_SKIPDEFAULT Or CDRF_SKIPPOSTPAINT
'        If .it Mod 2 <> 0 Then Exit Sub
'        Dim tp As Long, bt As Long
'        List.GetItemRect .it, LVIR_BOUNDS, , tp, , bt
'        StretchBlt GetDC(List.hWnd), _
'            0, tp, 10, bt, _
'            Form1.hdc, _
'            0, 0, 30, 30, _
'            vbSrcCopy
    ElseIf .dwDrawStage = CDDS_ITEMPREPAINT Then
'        ret_val = CDRF_NOTIFYITEMDRAW
'        ret_val = CDRF_NOTIFYPOSTPAINT

        '      
        If Not List.ItemVisible(.it) Then Exit Sub
        
        .uItemState = .uItemState And Not CDIS_FOCUS And Not CDIS_SELECTED '   
        Select Case True
        Case List.ItemSelected(.it): ' 
            udtNMLVCUSTOMDRAW.clrTextBk = C_PlaylistSelectBack
        Case .it Mod 2 <> 0 '   
            udtNMLVCUSTOMDRAW.clrTextBk = C_PlaylistBack2
        End Select
        
        If .it = List.playing Then
            If Not NotPlaying Then _
                udtNMLVCUSTOMDRAW.clrTextBk = C_PlaylistPlayBack
            udtNMLVCUSTOMDRAW.clrText = C_PlaylistPlayFore
        ElseIf .it = List.following Then
            udtNMLVCUSTOMDRAW.clrText = C_PlaylistNextFore
        End If
        
'        If checkRegExpMask(List.p_item(.it).song, Form1.Text1) Then _
'            udtNMLVCUSTOMDRAW.clrTextBk = &HC0FFC0
        
        CopyMemory ByVal lParam, udtNMLVCUSTOMDRAW, Len(udtNMLVCUSTOMDRAW)
        
        '      
        Dim item As playItem
        Set item = List.p_item(.it)
        If Not item.gotTags Then
            If Not item.remote Then
                Dim chan As Long
                If b(chan, BASS_StreamCreateFile(BASSFALSE, StrPtr(item.file), item.offset, item.length, BASS_UNICODE)) Then
                    item.assignt = getStreamTags(chan)
    '                qDebug List.p_item(.it).song, List.p_item(.it).gotTags
                    item.timing = BASS_ChannelBytes2Seconds(chan, BASS_ChannelGetLength(chan, BASS_POS_BYTE))
                    item.flen = BASS_StreamGetFilePosition(chan, BASS_FILEPOS_END)
                    Call BASS_StreamFree(chan)
                Else
                    item.invalid = True
                End If
            End If
            incr timing.files
            incrTiming item.timing
            Call signalUpdateListInfo
            item.gotTags = True ' 
        End If

        If item.invalid Then ' 
            udtNMLVCUSTOMDRAW.clrText = RGB(200, 200, 200)
'            Call SelectObject(udtNMLVCUSTOMDRAW.nmcd.hDC, rFont.hFont)
            CopyMemory ByVal lParam, udtNMLVCUSTOMDRAW, Len(udtNMLVCUSTOMDRAW)
'            ret_val = ret_val Or CDRF_NEWFONT
        End If
    End If
    End With
End Sub

'Module Interaction functions
Public Sub slotSongStart(ByVal status As Long, ByRef info As playItem)
    '     
    If Not inBounds(List.playing, 0, List.Count - 1) Then Exit Sub
    
    If List.p_item(List.playing).gotTags Then
        decr timing.files
        decrTiming List.p_item(List.playing).timing
    End If
    
    If status = playing Then
        NotPlaying = False
        List.p_item(List.playing).assign = info
        List.RedrawItem List.playing
        List.p_item(List.playing).invalid = False
        List.EnsureVisible List.playing '  
    ElseIf status = invalid Then
        NotPlaying = True
        List.p_item(List.playing).invalid = True
        List.EnsureVisible List.playing '  
    Else
        qError id & ":got unknown playing status - " & status
    End If
    
    If List.p_item(List.playing).gotTags Then
        incr timing.files
        incrTiming List.p_item(List.playing).timing
    End If
    Call signalUpdateListInfo
End Sub

Public Sub find(ByVal search As String, Optional ByVal fromNext As Boolean)
    Dim i As Long, item As playItem, from As Long
    from = List.ListIndex + IIf(fromNext, 1, 0)
    If from = -1 Then from = List.Count - 1 Else If from > List.Count - 1 Then from = 0
    If Not inBounds(from, 0, List.Count - 1) Then Exit Sub
    For i = from To List.Count - 1
        Set item = List.p_item(i)
        If InStr(1, item.song, search, vbTextCompare) Then
            List.ListIndex = i
            Exit Sub
        ElseIf InStr(1, item.artist, search, vbTextCompare) Then
            List.ListIndex = i
            Exit Sub
        ElseIf InStr(1, item.album, search, vbTextCompare) Then
            List.ListIndex = i
            Exit Sub
        ElseIf InStr(1, PathFilename(List.p_item(i).file), search, vbTextCompare) Then
            List.ListIndex = i
            Exit Sub
        End If
    Next i
    For i = 0 To from - 1
        Set item = List.p_item(i)
        If InStr(1, item.song, search, vbTextCompare) Then
            List.ListIndex = i
            Exit Sub
        ElseIf InStr(1, item.artist, search, vbTextCompare) Then
            List.ListIndex = i
            Exit Sub
        ElseIf InStr(1, item.album, search, vbTextCompare) Then
            List.ListIndex = i
            Exit Sub
        ElseIf InStr(1, PathFilename(List.p_item(i).file), search, vbTextCompare) Then
            List.ListIndex = i
            Exit Sub
        End If
    Next i
End Sub

Public Sub nextTrack()
    Call nextTrack_
End Sub

Public Sub prevTrack()
    Call nextTrack_(True)
End Sub

'use to cpy items between lists'''
Public Sub slotCopyStream(ByVal newItem As playItem)
'    qDebug "L", id, "Copy item to list"
    List.p_add newItem
    If newItem.gotTags Then
        incr timing.files
        incrTiming newItem.timing
    End If
    List.RedrawItem List.Count - 1
End Sub
''''''

Public Property Let chooseMethod(ByVal mtd As ENUM_choose)
    If mtd <> chooseMethod Then
        qDebug "L", id, "Core changes choose method to", mtd
        chooseMethod_ = mtd
        If chooseMethod_ = RANDOM Then _
            randomQueue = getRandomList(List.Count) '  
        List.following = nextTrackIndex()
        Form1.slotChooseMethodChanged
    End If
End Property

Public Property Get chooseMethod() As ENUM_choose
    chooseMethod = chooseMethod_
End Property
'-------------------------------

'  \
Private Sub nextTrack_(Optional ByVal goBack As Boolean = False)
    con.WriteLine "L{0}: {1} track", d_GENERAL, id, IIf(goBack, "previous", "next")
    Dim i As Long
    If List.Count > 0 Then
        If Not goBack Then ' FW
            List.playing = List.following
        ElseIf goBack And Not NotPlaying Then ' RW  
            If chooseMethod_ = LINEAR Then i = List.playing _
            Else If chooseMethod_ = RANDOM Then i = findValueInList(List.playing, randomQueue) '     
            Call iterate(i, List.Count - 1, goBack)
            If chooseMethod_ = LINEAR Then List.playing = i _
            Else If chooseMethod_ = RANDOM Then List.playing = randomQueue(i) '   
        Else
            ' RW   
        End If
        List.following = nextTrackIndex()
        Call Form1.slotSongStart(List.p_item(List.playing))
    Else
        Call Form1.slotSongStart
    End If
End Sub

Private Function nextTrackIndex() As Long
    If List.Count > 0 Then
        nextTrackIndex = List.playing
        If chooseMethod_ = LINEAR Then
            Call iterate(nextTrackIndex, List.Count - 1)
        ElseIf chooseMethod_ = RANDOM Then
            If UUBound(randomQueue) > -1 Then
                nextTrackIndex = findValueInList(nextTrackIndex, randomQueue) '     
                Call iterate(nextTrackIndex, List.Count - 1) '  1
                nextTrackIndex = randomQueue(nextTrackIndex) '   
            Else
                qError "Can't get nextTrackIndex from empty random array"
            End If
        End If
    Else
        nextTrackIndex = -1
    End If
End Function

Public Sub slotPlayItem(ByVal iitem As Long)
    Dim file As String, col As Collection
    file = List.p_item(iitem).file
    If Not List.p_item(iitem).remote And checkRegExpMask(file, ".*\.ogg", vbTextCompare) Then
        If List.p_item(iitem).offset = 0 And List.p_item(iitem).length = 0 Then
            Set col = ReadChainedOgg(file)
            If col.Count > 1 Then _
                splitChainedOgg iitem, col
        End If
    End If
   
    List.playing = iitem
    List.following = nextTrackIndex
    Call Form1.slotSongStart(List.p_item(iitem))
End Sub

',   ,   
Public Sub slotChannelStopped()
    If List.playing > -1 Then
        NotPlaying = True
'        Stop '   .
        List.RedrawItem List.playing
    End If
End Sub

Public Function hBound() As Long
    hBound = List.Count - 1
End Function

' - 
Public Sub populationStart()
'    tmr_explore.Enabled = False
'    ind_e = List.count + 1
    List.block = True
End Sub

'  (\url)  
Public Sub slotAddStream(ByRef src As String, Optional ByVal remote As Boolean = False, Optional ByVal before As Long = -1, Optional offset As Long, Optional length As Long)
    Dim item As New playItem
    item.file = src
    item.remote = remote
    item.offset = offset
    item.length = length
    List.p_add item, before
End Sub

'Reads playlist files
'Redraw should be blocked by caller
Public Sub slotAddPlaylist(ByRef file As String, ByVal Format As Byte)
    Dim dat() As Byte, st() As String
    Call populationStart
    Select Case Format
    Case 0: 'M3U
        dat = io.ReadBytesFromFile(file)
        st = Split(StrConv(dat, vbUnicode), _
            IIf(InStrB(1, dat, ChrB(&HD) & ChrB(&HA)), vbNewLine, vbLf)) 'CRLF or LF splitter
        addStreamList st(), PathFolder(file)
    Case 1: 'M3U8
        dat = io.ReadBytesFromFile(file)
        st = Split(dec_UTF8_arr(dat), _
            IIf(InStrB(1, dat, ChrB(&HD) & ChrB(&HA)), vbNewLine, vbLf)) 'CRLF or LF splitter
        addStreamList st(), PathFolder(file)
    Case 2: 'PLS
        Dim Count As Long, i As Long, tmp As String
        If b(Count, val(IniStringPrivate("playlist", "NumberOfEntries", 0, file))) Then
            ReDim st(Count - 1) As String
            For i = 0 To Count - 1
                st(i) = IniStringPrivate("playlist", "File" & i + 1, 0, file)
            Next i
            addStreamList st(), PathFolder(file)
        End If
    Case Else:
        qError "Unknown playlist format passed."
    End Select
    Call populationFinish
End Sub

Private Sub addStreamList(ByRef st() As String, ByRef relTo As String)
    Dim i As Long, uub As Long
    uub = UUBound(st)
    For i = 0 To uub
        st(i) = Trim$(st(i))
        If Not checkRegExpMask(st(i), "#.*") And LenB(st(i)) Then 'not a comment
            If checkRegExpMask(st(i), REG_EXP_URL) Then 'Url
                slotAddStream st(i), True
            ElseIf checkRegExpMask(st(i), "[a-zA-Z]:\\.*") Then 'Absolute path
                slotAddStream st(i), False
            Else
                slotAddStream relTo & "\" & st(i), False
            End If
        End If
    Next i
End Sub

'  - 
Public Sub populationFinish()
    List.block = False
    If chooseMethod_ = RANDOM Then _
        randomQueue = getRandomList(List.Count) ' -,   
    List.following = nextTrackIndex
    Call signalUpdateListInfo
''
'    If ind_e <= playlist.count Then _
'        tmr_explore.Enabled = True   '
''
End Sub

'  
'     
Public Sub sendSelectedTo(Optional ByRef lst As frm_plst, Optional ByVal copy As Boolean = False)
qDebug "L", id, "Remove or copy selected items"
    Dim item As Long, toNowhere As Boolean, play As Long
    If List.SelectedCount = 0 Then Exit Sub
    toNowhere = (lst Is Nothing)
    
    '     Shift+Del
    If lst Is Nothing Then toNowhere = True _
    Else If lst.id = id Then Exit Sub '   
    
    If Not toNowhere Then _
        lst.populationStart
    If Not copy Then
        Call populationStart
        play = List.keyByIndex(List.playing)
        If List.ItemSelected(List.playing) Then NotPlaying = True
    End If
    
    item = List.SelectedItem()
    While item <> -1
        If Not toNowhere Then _
            lst.slotCopyStream List.p_item(item)
        If Not copy Then
            If List.p_item(item).gotTags Then
                decr timing.files
                decrTiming List.p_item(item).timing
            End If
            List.p_rem item
            item = List.SelectedItem()
        Else
            item = List.SelectedItem(item)
        End If
    Wend
    
    If Not copy Then
        List.playing = List.indexByKey(play)
        List.following = nextTrackIndex()
        Call populationFinish
    End If
    If Not toNowhere Then _
        lst.populationFinish
End Sub

Private Sub List_DragBegin(ByVal iitem As Long, ByVal iSubItem As Long, ByVal Button As MouseButtonConstants)
    dragging = True
End Sub

Private Sub List_FilesDropped(Obj As Collection, ByVal x As Long, ByVal y As Long)
    Dim i As Integer, j As Integer, item As Long, play As Long, Count As Long
    If b(Count, Obj.Count) Then
        If checkRegExpMask(Obj(1), ".*\.m3u", vbTextCompare) Then 'M3U?
            Form1.slotAddNewPlaylist Obj(1), 0
        ElseIf checkRegExpMask(Obj(1), ".*\.m3u8", vbTextCompare) Then 'M3U8?
            Form1.slotAddNewPlaylist Obj(1), 1
        ElseIf checkRegExpMask(Obj(1), ".*\.pls", vbTextCompare) Then 'PLS?
            Form1.slotAddNewPlaylist Obj(1), 2
        Else
            item = List.HitTest(0, y)
            If item = 65535 Then item = -1
            StackPush Form1.Caption
            Call populationStart
            play = List.keyByIndex(List.playing)
            For i = 1 To Count
                If io.addressIsFolder(Obj(i)) Then
                    Call io.enumFilesRecursive(Obj(i), ".*\.(" & rxFilter & ")")
                    For j = 1 To io.filesResult.Count
                        Call slotAddStream(io.filesResult(j), , item)
                    Next
                Else
                    If Count = 1 Then
                        Call slotAddStream(Obj(i), , item)
                    ElseIf checkRegExpMask(Obj(i), ".*\.(" & rxFilter & ")", vbTextCompare) Then
                        Call slotAddStream(Obj(i), , item)
                    End If
                End If
            Next i
            List.playing = List.indexByKey(play)
            Call populationFinish
            Form1.Caption = StackPop
        End If
    End If
End Sub

Private Sub List_ItemActivate(ByVal iIndex As Long)
    slotPlayItem iIndex
End Sub

Private Sub List_KeyDown(KeyCode As Long, ByVal Shift As Integer)
    Dim i As Long, j As Long, selc As Long
    Select Case KeyCode
    Case vbKeyDelete:
        Call sendSelectedTo(IIf(Shift = vbShiftMask Or id = -1, _
                                    Nothing, Form1.tabs.getOne(-1)))
    Case vbKeyC And Shift = vbCtrlMask:
        MousePointer = vbHourglass
        selc = List.SelectedCount
        If selc = 0 Then Exit Sub
        ReDim arr(selc - 1) As String
        i = List.SelectedItem()
        While i <> -1
            arr(j) = List.p_item(i).file
            incr j
            i = List.SelectedItem(i)
        Wend
        io.putToClipboard Join(arr, vbNewLine)
        MousePointer = vbDefault
    End Select
End Sub

Public Sub focus()
    List.SetFocus
End Sub

Public Sub SelectAll()
    List.SelectAll
End Sub

Public Property Get playlistWnd() As Long
    playlistWnd = List.hwnd
End Property

Private Sub List_MouseUp(ByVal Button As MouseButtonConstants, ByVal x As Long, ByVal y As Long, ByVal Shift As Integer)
    If dragging Then
        dragging = False
        If sendToTab <> -1 Then '   
            sendSelectedTo Form1.tabs.getOne(sendToTab), kbdKeyHold(vbKeyControl)
            Form1.tabs.draw
        Else                    '
            Dim item As Long, i As Long, n As Long, shiftpos As Boolean
            Dim playkey As Long, nextkey As Long
            If List.SelectedCount = 0 Then Exit Sub
            item = IIf( _
                    y < 0, 0, _
                    IIf(y > List.Bottom, -1, _
                    List.HitTest(0, y)))
            If item = -1 Then item = List.Count - 1
            If List.ItemSelected(item) = True Then Exit Sub '    
            MousePointer = vbHourglass
            playkey = List.keyByIndex(List.playing)
            nextkey = List.keyByIndex(List.following)
            ReDim Keys(List.SelectedCount - 1) As Long
            i = List.SelectedItem()
            While i <> -1
                Keys(n) = List.keyByIndex(i)
                incr n
                i = List.SelectedItem(i)
            Wend
            If List.indexByKey(Keys(0)) < item Then shiftpos = True
            item = List.keyByIndex(item) '    
            For i = 0 To n - 1
                List.Sort Keys(i), item
                If shiftpos Then _
                    item = Keys(i)
            Next i
            List.SelectedItem = -1
            For i = 0 To n - 1
                List.SelectedItem = List.indexByKey(Keys(i))
            Next i
            List.playing = List.indexByKey(playkey)
            List.following = List.indexByKey(nextkey)
            List.RedrawVisibleItems
            MousePointer = vbDefault
        End If
    End If
End Sub

Private Sub mnu_prelisten_Click()
    If frm_prelisten.Prelisten(List.p_item(List.ListIndex)) Then
        Dim bot As Long, righ As Long, pt As POINTAPI, pt2 As POINTAPI
        Call List.GetItemRect(List.ListIndex, LVIR_BOUNDS, , , righ, bot)
        pt.x = 50
        pt2.x = righ
        pt.y = bot - 1
        ClientToScreen List.hwnd, pt
        ClientToScreen List.hwnd, pt2
        frm_prelisten.Move pt.x * Screen.TwipsPerPixelX, pt.y * Screen.TwipsPerPixelY, (pt2.x - pt.x) * Screen.TwipsPerPixelX
        frm_prelisten.show
    End If
End Sub

Private Sub mnu_save_chainlink_Click()
    Dim item As playItem, ext As String
    Dim lHandle As Long, lHandle2 As Long
    Dim dat() As Byte, length As Long, Size As Long, nbytes As Long
    Set item = List.p_item(List.ListIndex)
    ext = PathExt(item.file)
    io.ShowSave hwnd, IIf(LenB(ext), "*." & ext & "|" & "*." & ext, "*.*|*.*"), "Save track...", s2(item.artist, " - ", item.song) & "." & ext
    If io.filesResult.Count > 0 Then
        lHandle = io.openFile(item.file, OPEN_EXISTING, GENERIC_READ, FILE_SHARE_READ)
        If lHandle <> INVALID_HANDLE_VALUE Then
            lHandle2 = io.openFile(io.filesResult(1), CREATE_ALWAYS)
            If lHandle2 <> INVALID_HANDLE_VALUE Then
                Size = io.sizeOfFile(lHandle)
                length = IIf(item.length, item.length, Size - item.offset)
                If item.offset + length <= Size Then
                    ReDim dat(length - 1)
                    nbytes = io.readFiledata(lHandle, item.offset, length, dat)
                    If nbytes = length Then _
                        io.writeBytesToFile lHandle2, dat _
                    Else qError "Failed to read appropriate byte count from source file"
                Else
                    qError "File part is out of bounds!"
                End If
                io.closeFile lHandle
                io.closeFile lHandle2
            Else
                io.closeFile lHandle
                qError "Cannot open dest file " & io.filesResult(1)
            End If
        Else
            qError "Cannot open source file " & item.file
        End If
    End If
End Sub

Private Sub mnu_setnxt_Click()
    List.following = List.ListIndex
End Sub

Private Sub mnu_upload_Click()
On Error GoTo 1:
    Dim item As playItem
    Set item = List.p_item(List.ListIndex)
    If item.isChainLink Then _
        If MsgBox("It's a part of chained file " & PathFilename(item.file, True) & vbNewLine & _
                "Do you want to upload whole file? (" & io.sizeOfFileByPath(item.file) \ 1048576 & "MB)", vbOKCancel Or vbInformation, "Upload") _
            = vbCancel Then Exit Sub
    Shell AppPath & "upload.exe """ & List.p_item(List.ListIndex).file & """", vbNormalFocus
Exit Sub
1: qError "Error", Err.Number, Err.Description
End Sub

Private Sub pnl_sort_MouseDown(Button As Integer, Shift As Integer, x As Single, y As Single)
    If Button = vbLeftButton Then _
        Call Sort(whichColumnClicked(x))
End Sub

' 
Private Sub Sort(ByVal sortBy As Byte)
    Dim play As Long
    If List.Count < 2 Then Exit Sub
    
    MousePointer = vbHourglass
    play = List.keyByIndex(List.playing)
    
    Select Case sortBy
    Case 0: List.QuickSort0 0, List.Count - 1
    Case 1: List.QuickSort1 0, List.Count - 1
    Case 2: List.QuickSort2 0, List.Count - 1
    Case Else: List.QuickSort3 0, List.Count - 1
    End Select
    
    If chooseMethod_ = RANDOM Then _
        randomQueue = getRandomList(List.Count) ' -,   
    List.playing = List.indexByKey(play)
    List.following = nextTrackIndex()
    List.RedrawVisibleItems
    List.EnsureVisible List.playing
    MousePointer = vbDefault
End Sub

Private Function whichColumnClicked(ByVal pt_x As Integer) As Integer
    Dim n As Integer, i As Integer, x As Integer
    n = List.ColumnsCount
    x = 1
    For i = 0 To n - 1
        x = x + List.ColumnWidth(i)
        If pt_x < x Then
            whichColumnClicked = i
            Exit Function
        End If
    Next i
End Function

Private Sub drawSortPanel()
    Dim n As Integer, i As Integer, x As Integer, clr As Long
    pnl_sort.Cls
    With List
    n = .ColumnsCount
    x = 1
    For i = 0 To n - 1
        If .ColumnWidth(i) > 0 Then
            If i > 0 And i < n - 1 Then _
                pnl_sort.Line (x, 0)-(x, pnl_sort.ScaleHeight / 1.2), RGB(192, 192, 192)
            pnl_sort.CurrentX = x + 4
            pnl_sort.CurrentY = 0
            clr = ForeColor
            pnl_sort.Print List.ColumnText(i)
            x = x + .ColumnWidth(i)
        End If
    Next i
    End With
End Sub

Private Sub pnl_sort_Resize()
    Call drawSortPanel
End Sub

'       ( )
Private Sub tmr_explore_Timer()
'    Dim chan As Long, skip As Boolean
'    If List.ItemVisible(ind_e - 1) Then skip = True
'    If List.p_item(ind_e - 1).gotTags Then skip = True
'    If List.p_item(ind_e - 1).remote Then skip = True
'    If Not io.IsDriveFixed(Left$(List.p_item(ind_e - 1).file, 3)) Then skip = True
'    If Not skip Then
'        If b(chan, BASS_StreamCreateFile(BASSFALSE, StrPtr(List.p_item(ind_e - 1).file), 0, 0, 0)) Then
'            List.p_item(ind_e - 1).assignt = getStreamTags(chan)
'            List.p_item(ind_e - 1).tlen = BASS_ChannelBytes2Seconds(chan, BASS_ChannelGetLength(chan, BASS_POS_BYTE))
'            Call BASS_StreamFree(chan)
'            List.p_item(ind_e - 1).flen = FileLen(List.p_item(ind_e - 1).file)
'            updateListItem ind_e - 1
'            con.updateLine List.p_item(ind_e - 1).song & "[exp index=" & ind_e & "]", d_GENERAL
''       Else
''           List.ItemText(2, .dwItemSpec) = "X"
'        End If
'    End If
'    ind_e = ind_e + 1
'    If ind_e > List.count Then tmr_explore.Enabled = False
End Sub

Private Property Get OverallTiming() As String
    OverallTiming = HourMinSec(timing.length) & IIf(timing.files < List.Count, "+", "")
End Property

Public Sub signalUpdateListInfo()
'    Debug.Print "signalUpdateListInfo", Now
    If id = Form1.tabs.activeID Then _
        Form1.slotUpdateListInfo id, List.Count & " tracks, " & OverallTiming
End Sub

Private Function ReadChainedOgg(ByRef file As String) As Collection
    Set ReadChainedOgg = New Collection
    Const SIZEB As Long = 65536, SIZEBm As Long = SIZEB - 34, SIZEBm10 As Long = (SIZEB - 34) * 160
    Dim hndl As Long, OggS() As Byte, check(5) As Byte, nbytes As Long, j As Long
    Dim pos As Long, pos2 As Long
    ReDim dat(SIZEB - 1) As Byte
    OggS = StrConv("OggS" & vbNullChar & Chr$(2), vbFromUnicode)
    hndl = io.openFile(file, OPEN_EXISTING)
    If hndl <> INVALID_HANDLE_VALUE Then
        io.readFiledata hndl, 0, 6, check
        If StrComp(check, OggS) = 0 Then
            StackPush Form1.Caption
            Do
                nbytes = io.readFiledata(hndl, pos, SIZEB, dat)
                pos2 = 0
                Do
                    pos2 = InStrB(pos2 + 1, dat, OggS)
                    If pos2 Then
                        If pos2 <= nbytes - 34 Then
                            If dat(pos2 + 27) = &H1 Then _
                            If dat(pos2 + 28) = &H76 Then _
                            If dat(pos2 + 29) = &H6F Then _
                            If dat(pos2 + 30) = &H72 Then _
                            If dat(pos2 + 31) = &H62 Then _
                            If dat(pos2 + 32) = &H69 Then _
                            If dat(pos2 + 33) = &H73 Then _
                                ReadChainedOgg.Add pos + pos2 - 1
                        End If
                    Else
                        Exit Do
                    End If
                Loop
                pos = pos + SIZEBm
                If pos Mod SIZEBm10 = 0 Then
                    Form1.Caption = "Detecting Ogg chaining: " & pos \ 1048576 & "MB..."
                    DoPaintEvents
                End If
            Loop While nbytes = SIZEB
            Form1.Caption = StackPop
        Else
            qError "Wrong Ogg file"
        End If
        io.closeFile hndl
    Else
        qError "Cannot open Ogg file"
    End If
End Function

Private Sub splitChainedOgg(ByVal iIndex As Long, ByRef offsets As Collection)
    Dim Key As Long, Count As Long, i As Long, file As String
    Key = List.keyByIndex(iIndex)
    file = List.p_item(iIndex).file
    Count = offsets.Count
    For i = 1 To Count
        If i < Count Then _
            slotAddStream file, , List.indexByKey(Key), offsets(i), offsets(i + 1) - offsets(i) _
        Else slotAddStream file, , List.indexByKey(Key), offsets(i)
    Next i
    If List.p_item(List.indexByKey(Key)).gotTags Then
        decr timing.files
        decrTiming List.p_item(List.indexByKey(Key)).timing
    End If
    List.p_rem (List.indexByKey(Key))
End Sub

