VERSION 5.00
Begin VB.Form frm_snd 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Audica SoundLab"
   ClientHeight    =   3135
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   5025
   BeginProperty Font 
      Name            =   "Verdana"
      Size            =   8.25
      Charset         =   204
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   Icon            =   "frm_snd.frx":0000
   LinkTopic       =   "Form2"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   209
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   335
   StartUpPosition =   3  'Windows Default
   Begin VB.HScrollBar sldFX 
      Height          =   255
      Index           =   2
      Left            =   120
      Max             =   100
      TabIndex        =   11
      Top             =   2760
      Width           =   1575
   End
   Begin VB.HScrollBar sldFX 
      Height          =   255
      Index           =   1
      Left            =   120
      Max             =   100
      TabIndex        =   10
      Top             =   2400
      Width           =   1575
   End
   Begin VB.HScrollBar sldFX 
      Height          =   255
      Index           =   0
      Left            =   120
      Max             =   0
      Min             =   20
      TabIndex        =   8
      Top             =   2040
      Value           =   20
      Width           =   1575
   End
   Begin VB.Frame Frame1 
      Caption         =   "5 Band Equalizer"
      Height          =   1935
      Left            =   120
      TabIndex        =   0
      Top             =   0
      Width           =   4815
      Begin VB.CommandButton cmd_eqr_reset 
         Caption         =   "x"
         Height          =   225
         Left            =   4590
         TabIndex        =   7
         Top             =   0
         Width           =   225
      End
      Begin VB.PictureBox pic_eqr 
         AutoRedraw      =   -1  'True
         BackColor       =   &H00FFFFFF&
         BorderStyle     =   0  'None
         BeginProperty Font 
            Name            =   "MS Sans Serif"
            Size            =   8.25
            Charset         =   204
            Weight          =   400
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   1185
         Left            =   240
         ScaleHeight     =   79
         ScaleMode       =   3  'Pixel
         ScaleWidth      =   289
         TabIndex        =   1
         Top             =   300
         Width           =   4335
      End
      Begin VB.Label lbl_Hz 
         AutoSize        =   -1  'True
         Caption         =   "14.7k"
         Height          =   195
         Index           =   4
         Left            =   4200
         TabIndex        =   6
         Top             =   1605
         Width           =   480
      End
      Begin VB.Label lbl_Hz 
         AutoSize        =   -1  'True
         Caption         =   "12k"
         Height          =   195
         Index           =   3
         Left            =   3330
         TabIndex        =   5
         Top             =   1605
         Width           =   315
      End
      Begin VB.Label lbl_Hz 
         AutoSize        =   -1  'True
         Caption         =   "3k"
         Height          =   195
         Index           =   2
         Left            =   2300
         TabIndex        =   4
         Top             =   1605
         Width           =   210
      End
      Begin VB.Label lbl_Hz 
         AutoSize        =   -1  'True
         Caption         =   "600"
         Height          =   195
         Index           =   1
         Left            =   1170
         TabIndex        =   3
         Top             =   1605
         Width           =   315
      End
      Begin VB.Label lbl_Hz 
         AutoSize        =   -1  'True
         Caption         =   "170"
         Height          =   195
         Index           =   0
         Left            =   90
         TabIndex        =   2
         Top             =   1600
         Width           =   315
      End
   End
   Begin VB.Label lbl_FX_name 
      Caption         =   "Chorus"
      Height          =   255
      Index           =   2
      Left            =   1800
      TabIndex        =   13
      Top             =   2760
      Width           =   1335
   End
   Begin VB.Label lbl_FX_name 
      Caption         =   "Echo"
      Height          =   255
      Index           =   1
      Left            =   1800
      TabIndex        =   12
      Top             =   2400
      Width           =   1335
   End
   Begin VB.Label lbl_FX_name 
      Caption         =   "Reverberation"
      Height          =   255
      Index           =   0
      Left            =   1800
      TabIndex        =   9
      Top             =   2040
      Width           =   1335
   End
End
Attribute VB_Name = "frm_snd"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'    Copyright 2009, 2010 Makarov Andrey
'
'    This file is part of Audica - Open Simple Audio Player.
'
'    Audica is free software: you can redistribute it and/or modify
'    it under the terms of the GNU General Public License as published by
'    the Free Software Foundation, either version 3 of the License, or
'    (at your option) any later version.
'
'    Audica is distributed in the hope that it will be useful,
'    but WITHOUT ANY WARRANTY; without even the implied warranty of
'    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'    GNU General Public License for more details.
'
'    You should have received a copy of the GNU General Public License
'    along with Audica.  If not, see <http://www.gnu.org/licenses/>.

Option Explicit
Const EQ_UB = 4
Const EQ_NUM = EQ_UB + 1
Const GAIN_WDT = 30

Dim band_val(EQ_UB) As Single
Dim eqb(EQ_UB) As Long '5 band EQ
Dim fx(2) As Long 'Reverb, Echo, Flanger
Private Declare Function PolyBezier Lib "gdi32.dll" (ByVal hdc As Long, ByRef lppt As POINTAPI, ByVal cPoints As Long) As Long

Public Property Let gain(ByVal b As Integer, ByVal gain As Single)
    Dim p As BASS_DX8_PARAMEQ
    band_val(b) = gain
    Call BASS_FXGetParameters(eqb(b), p)
    p.fGain = gain
    Call BASS_FXSetParameters(eqb(b), p)
End Property

Private Property Get gain(ByVal b As Integer) As Single
    Dim p As BASS_DX8_PARAMEQ
    If b < 0 Or b > EQ_UB Then
        gain = 0
    Else
        gain = band_val(b)
'        Call BASS_FXGetParameters(eqb(b), p)
'        gain = p.fGain
    End If
End Property

Private Property Get band_wdt() As Integer
    band_wdt = pic_eqr.ScaleWidth / EQ_NUM
End Property

Private Property Get gainToY(ByVal gain As Single) As Integer
    gainToY = (GAIN_WDT \ 2 - gain) * (pic_eqr.ScaleHeight / GAIN_WDT)
End Property

Public Sub UpdateFX(ByVal F As Integer)
    Dim v As Integer
    v = sldFX(F).value
    
    Select Case F
    Case 0: 'Reverb
        Dim p As BASS_DX8_REVERB
        Call BASS_FXGetParameters(fx(F), p)
        p.fReverbMix = -0.012 * v * v * v
        Call BASS_FXSetParameters(fx(F), p)
    Case 1: 'Echo
        Dim p1 As BASS_DX8_ECHO
        Call BASS_FXGetParameters(fx(F), p1)
        p1.fWetDryMix = v
        Call BASS_FXSetParameters(fx(F), p1)
    Case 2: 'Flanger
        Dim p2 As BASS_DX8_CHORUS
        Call BASS_FXGetParameters(fx(F), p2)
        p2.fWetDryMix = v
        Call BASS_FXSetParameters(fx(F), p2)
    End Select
End Sub

Public Sub InitSFX(ByVal Handle As Long)
    ' setup the effects
    Dim i As Integer
    Dim p As BASS_DX8_PARAMEQ
    Dim Hz(EQ_UB) As Single: Hz(0) = 170: Hz(1) = 3001: Hz(2) = 3000: Hz(3) = 12000: Hz(4) = 14700

    p.fGain = 0
    p.fBandwidth = 18
    For i = 0 To EQ_UB
        eqb(i) = BASS_ChannelSetFX(Handle, BASS_FX_DX8_PARAMEQ, 0)
'        Debug.Print i, eqb(i)
        p.fCenter = Hz(i)
        p.fGain = band_val(i)
        Call BASS_FXSetParameters(eqb(i), p)
    Next i
    Call DrawEQR(, 12632256)
    
    fx(0) = BASS_ChannelSetFX(Handle, BASS_FX_DX8_REVERB, 0)
    UpdateFX (0)
    fx(1) = BASS_ChannelSetFX(Handle, BASS_FX_DX8_ECHO, 0)
    UpdateFX (1)
    fx(2) = BASS_ChannelSetFX(Handle, BASS_FX_DX8_CHORUS, 0)
    UpdateFX (2)
End Sub

Private Sub cmd_eqr_reset_Click()
    Dim i As Integer
    For i = 0 To EQ_UB
        gain(i) = 0
    Next i
    Call DrawEQR(, 12632256)
End Sub

Private Sub Form_Load()
    Call DrawEQR(, 12632256)
End Sub

Private Sub Form_QueryUnload(Cancel As Integer, UnloadMode As Integer)
    If UnloadMode = vbFormControlMenu Then Cancel = 1: hide
End Sub

Private Sub pic_eqr_MouseDown(Button As Integer, Shift As Integer, x As Single, y As Single)
If x < 0 Or x > pic_eqr.ScaleWidth Or y < 0 Or y > pic_eqr.ScaleHeight Then Exit Sub
    Dim band As Integer
    band = x \ band_wdt
    gain(band) = -y / (pic_eqr.ScaleHeight / GAIN_WDT) + GAIN_WDT \ 2
    Call DrawEQR(, 12632256)
'    Debug.Print band, gain(band)
End Sub

Private Sub DrawBezier(ByVal DC As Long, ByVal x1 As Long, ByVal x2 As Long, ByVal y1 As Long, ByVal y2 As Long)
    Dim p(3) As POINTAPI
    p(0).x = x1:            p(0).y = y1
    p(1).x = x1 + (x2 - x1) \ 2: p(1).y = y1
    p(2).x = x1 + (x2 - x1) \ 2: p(2).y = y2
    p(3).x = x2:            p(3).y = y2
    PolyBezier DC, p(0), 4
End Sub

Private Sub DrawEQR(Optional ByVal cCurve As Long, Optional ByVal cLines As Long, Optional ByVal cBack As Long)
    Dim i As Integer, wdth As Integer, hght As Integer
    wdth = pic_eqr.ScaleWidth
    hght = pic_eqr.ScaleHeight
    pic_eqr.Cls
    pic_eqr.BackColor = IIf(cBack, cBack, pic_eqr.BackColor)
    pic_eqr.Line (0, hght \ 2)-(wdth, hght \ 2), cLines
    For i = -1 To EQ_UB
        DrawBezier pic_eqr.hdc, (0.5 + i) * band_wdt, (1.5 + i) * band_wdt, gainToY(gain(i)), gainToY(gain(i + 1))
        pic_eqr.Line ((0.5 + i) * band_wdt, 0)-((0.5 + i) * band_wdt, hght), cLines
    Next i
End Sub

Private Sub pic_eqr_MouseMove(Button As Integer, Shift As Integer, x As Single, y As Single)
    If Button = vbLeftButton Then _
        pic_eqr_MouseDown Button, Shift, x, y
End Sub

Private Sub sldFX_Change(Index As Integer)
    Call UpdateFX(Index)
End Sub

Private Sub sldFX_Scroll(Index As Integer)
    Call UpdateFX(Index)
End Sub
