Attribute VB_Name = "int_act"
'    Copyright 2009, 2010 Makarov Andrey
'
'    This file is part of Audica - Open Simple Audio Player.
'
'    Audica is free software: you can redistribute it and/or modify
'    it under the terms of the GNU General Public License as published by
'    the Free Software Foundation, either version 3 of the License, or
'    (at your option) any later version.
'
'    Audica is distributed in the hope that it will be useful,
'    but WITHOUT ANY WARRANTY; without even the implied warranty of
'    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'    GNU General Public License for more details.
'
'    You should have received a copy of the GNU General Public License
'    along with Audica.  If not, see <http://www.gnu.org/licenses/>.

Option Explicit
Public notifyWheel As New Collection
Public keyboardPress As New Collection
Dim Obj As Object

Private Declare Function DefWindowProc Lib "user32.dll" Alias "DefWindowProcA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Private Declare Function SendMessage Lib "user32.dll" Alias "SendMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByRef lParam As Any) As Long
Private Const WM_COPYDATA As Long = &H4A
Private Type COPYDATASTRUCT
    dwData As Long
    cbData As Long
    lpData As Long
End Type
Private Const WM_USER As Long = &H400
Private Const WM_WHEEL As Long = (WM_USER + 1)
Private Const WM_KEYS As Long = (WM_USER + 2)
Private Const WM_REGHOOK As Long = (WM_USER + 3)
Private Const WM_UNREGHOOK As Long = WM_REGHOOK

Private Declare Function CreateWindowEx Lib "user32.dll" Alias "CreateWindowExA" (ByVal dwExStyle As Long, ByVal lpClassName As String, ByVal lpWindowName As String, ByVal dwStyle As Long, ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hWndParent As Long, ByVal hMenu As Long, ByVal hInstance As Long, ByRef lpParam As Any) As Long
Private Declare Function SetWindowLong Lib "user32.dll" Alias "SetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long
Private Const GWL_WNDPROC As Long = -4
Private Declare Function FindWindow Lib "user32.dll" Alias "FindWindowA" (ByVal lpClassName As String, ByVal lpWindowName As String) As Long
Private Declare Function DestroyWindow Lib "user32.dll" (ByVal hwnd As Long) As Long
Private Declare Sub CopyMemory Lib "kernel32.dll" Alias "RtlMoveMemory" (ByRef Destination As Any, ByRef Source As Any, ByVal length As Long)
Public wnd As Long, hookwnd As Long, dummy As Long, serverChecked As Boolean

Private Const WINDOW_NAME As String = "Audica_Dummy"
Private commandBuffer As New Collection

'    \false\
Public Function int_isClient() As Boolean
    If Not serverChecked Then
        If Not b(wnd, FindWindow(vbNullString, WINDOW_NAME)) Then _
            int_becomeServer
        serverChecked = True ' 
    End If
    int_isClient = wnd
End Function

' 
Private Sub int_becomeServer()
'Dim W As Long, buf(255) As Byte, i As Long, s As String


    dummy = CreateWindowEx(0, "STATIC", WINDOW_NAME, 0, 0, 0, 0, 0, 0, 0, 0, ByVal 0)
    SetWindowLong dummy, GWL_WNDPROC, AddressOf int_WindowProc
'    Dim cl As WNDCLASS
'
'    cl.lpszClassName = LASTFM_CLASS
'    b cl.lpfnwndproc, AddressOf int_LastfmDummyProc
'    cl.hInstance = 0
'    Call RegisterClass(cl)
''    LastfmDummy(1) = CreateWindowEx(0, "STATIC", "Chooooo - Chooooo", 0, 0, 0, 0, 0, 0, 0, App.hInstance, ByVal 0&)
'    LastfmDummy(0) = CreateWindowEx(0, LASTFM_CLASS, "Chooooo - Chooooo", 0, 0, 0, 0, 0, 0, 0, 0, ByVal 0&)
'
'If b(W, FindWindow(LASTFM_CLASS, vbNullString)) Then
'    SendMessage W, WM_GETTEXT, 255, buf(0)
'    s = StrConv(buf, vbUnicode)
'    i = InStr(1, s, vbNullChar)
'    If i Then s = Mid$(s, 1, i - 1)
'    Debug.Print W, s
'Else
'    Debug.Print "Not found"
'End If
End Sub

'Private Function int_LastfmDummyProc(ByVal hWnd As Long, ByVal uMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
'    int_LastfmDummyProc = DefWindowProc(hWnd, uMsg, wParam, lParam)
'End Function

'  
Public Sub int_sendData(ByVal str As String, ByVal id As Long)
    Dim dat As COPYDATASTRUCT
    dat.cbData = LenB(str)
    dat.lpData = StrPtr(str)
    SendMessage wnd, WM_COPYDATA, id, dat
End Sub

'  ( int_isClient = false)
Public Sub int_destroyServer_ifNotClient()
    If Not int_isClient Then
        DestroyWindow dummy
'        DestroyWindow LastfmDummy(0)
'        DestroyWindow LastfmDummy(1)
'        UnregisterClass LASTFM_CLASS, 0
    End If
End Sub

Public Sub int_unhook()
    If hookwnd Then _
        SendMessage hookwnd, WM_UNREGHOOK, 0, 0
End Sub

Private Function int_WindowProc(ByVal hwnd As Long, ByVal uMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
    Dim cds As COPYDATASTRUCT
    Select Case uMsg
    Case WM_COPYDATA:
        Call CopyMemory(cds, ByVal lParam, Len(cds))
        ReDim buf(cds.cbData - 1) As Byte
        Call CopyMemory(buf(0), ByVal cds.lpData, cds.cbData)
        qDebug wParam
        If Not audicaLoaded Then
            commandBuffer.Add buf
        Else
            qDebug "WM_COPYDATA from hInstance=" & wParam, time
            LoadFromCommand buf
            Form1.show
        End If
    Case WM_WHEEL:
        For Each Obj In notifyWheel
            Call Obj.slotNotifyWheel(lParam, getModificators)
        Next Obj
    Case WM_KEYS:
        kbd_presses = IIf(lParam > 0, True, False)
        For Each Obj In keyboardPress
            Call Obj.slotKeyboardPress(kbd_presses)
        Next Obj
    Case WM_REGHOOK:
        qDebug "Hook tool resposed", lParam
        hookwnd = lParam
    End Select
    int_WindowProc = DefWindowProc(hwnd, uMsg, wParam, lParam)
End Function

'       
'    ,     
Public Sub int_procBuffer()
    Dim i As Integer
    If commandBuffer.Count > 0 Then
        For i = 1 To commandBuffer.Count
            qDebug "Buffered WM_COPYDATA, no=" & i, time
            LoadFromCommand commandBuffer(i)
        Next i
        Form1.show
    End If
End Sub


