VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "playItem"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'    Copyright 2009, 2010 Makarov Andrey
'
'    This file is part of Audica - Open Simple Audio Player.
'
'    Audica is free software: you can redistribute it and/or modify
'    it under the terms of the GNU General Public License as published by
'    the Free Software Foundation, either version 3 of the License, or
'    (at your option) any later version.
'
'    Audica is distributed in the hope that it will be useful,
'    but WITHOUT ANY WARRANTY; without even the implied warranty of
'    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'    GNU General Public License for more details.
'
'    You should have received a copy of the GNU General Public License
'    along with Audica.  If not, see <http://www.gnu.org/licenses/>.

Option Explicit
Private Const vbDoubleNull As String = vbNullChar & vbNullChar
Private Const ConstIStr As String = "i" & vbDoubleNull
Private m_list_album As String
Private m_list_artist As String
Private m_list_song As String
Private m_list_track As String
Private m_list_timing As String

Private m_album As String   'station website for remote
Private m_artist As String  'station name for remote
Public Comment As String    'bitrate for remote
Public composer As String
Public copyright As String
Public genre As String      'genre for remote
Private m_song As String    'metatags for remote
Private m_track As String
Public year As String
Public gotTags As Boolean '   = true

Public offset As Long
Public length As Long

Public file As String
Public m_timing As Single 'Song length (s)
Public flen As Long 'File size
Public remote As Boolean

Public invalid As Boolean '  /  

'Stream info
Public channels As Long
Public frequency As Long
Public ctype As Long
Public Plugin As Long
'-----------

Public Property Get album() As String: album = m_album: End Property
Public Property Get list_album() As Long: list_album = StrPtr(m_list_album): End Property
Public Property Let album(ByVal st As String)
    m_album = st
    If LenB(st) <> 0 Then
        m_list_album = st & s(" (", year, ")") & vbDoubleNull
    Else
        m_list_album = s("(", year, ")") & vbDoubleNull
    End If
End Property

Public Property Get artist() As String: artist = m_artist: End Property
Public Property Get list_artist() As Long: list_artist = StrPtr(m_list_artist): End Property
Public Property Let artist(ByVal s As String)
    m_artist = s
    m_list_artist = s & vbDoubleNull
End Property

Public Property Get song() As String: song = m_song: End Property
Public Property Get list_song() As Long: list_song = StrPtr(m_list_song): End Property
Public Property Let song(ByVal s As String)
    m_song = s
    m_list_song = s & vbDoubleNull
End Property

Public Property Get track() As String: track = m_track: End Property
Public Property Get list_track() As Long: list_track = StrPtr(m_list_track): End Property
Public Property Let track(ByVal s As String)
    m_track = s
    m_list_track = s & vbDoubleNull
End Property

Public Property Get timing() As Single: timing = m_timing: End Property
Public Property Get list_timing() As String
    If Not remote Then list_timing = StrPtr(m_list_timing) _
    Else list_timing = StrPtr(ConstIStr)
End Property
Public Property Let timing(ByVal sec As Single)
    m_timing = sec
    m_list_timing = HourMinSec(sec) & vbDoubleNull
End Property

Public Property Get isChainLink() As Boolean
    isChainLink = (offset <> 0 Or length <> 0)
End Property

'Assigns song tags
Public Property Let assignt(ByRef newItem As playItem)
    year = newItem.year
    album = newItem.album
    artist = newItem.artist
    Comment = newItem.Comment
    composer = newItem.composer
    copyright = newItem.copyright
    genre = newItem.genre
    gotTags = newItem.gotTags
    song = newItem.song
    track = newItem.track
End Property

'Assigns stream info
Public Property Let assignf(ByRef newItem As playItem)
    channels = newItem.channels
    frequency = newItem.frequency
    ctype = newItem.ctype
    Plugin = newItem.Plugin
End Property

Public Property Let assign(ByRef newItem As playItem)
    assignt = newItem
    assignf = newItem
    file = newItem.file
    flen = newItem.flen
    remote = newItem.remote
    timing = newItem.timing
End Property

Private Sub Class_Initialize()
    m_list_album = vbDoubleNull
    m_list_artist = vbDoubleNull
    m_list_song = vbDoubleNull
    m_list_track = vbDoubleNull
    m_list_timing = vbDoubleNull
End Sub
